/* BottomBar.c generated by valac 0.56.17, the Vala compiler
 * generated from BottomBar.vala, do not modify */

/*
 * Copyright (c) 2022-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_BOTTOM_BAR_0_PROPERTY,
	HE_BOTTOM_BAR_TITLE_PROPERTY,
	HE_BOTTOM_BAR_DESCRIPTION_PROPERTY,
	HE_BOTTOM_BAR_MODE_PROPERTY,
	HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY,
	HE_BOTTOM_BAR_NUM_PROPERTIES
};
static GParamSpec* he_bottom_bar_properties[HE_BOTTOM_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeBottomBarPrivate {
	GtkBox* main_box;
	GtkBox* left_box;
	GtkBox* center_box;
	GtkBox* right_box;
	GtkLabel* title_label;
	GtkLabel* description_label;
	GtkOverlay* overlay_parent;
	HeBottomBarMode _mode;
};

static gint HeBottomBar_private_offset;
static gpointer he_bottom_bar_parent_class = NULL;
static GtkBuildableIface * he_bottom_bar_gtk_buildable_parent_iface = NULL;

static void he_bottom_bar_update_mode_styling (HeBottomBar* self);
static void he_bottom_bar_setup_overlay (HeBottomBar* self,
                                  GtkWidget* target_widget);
static void he_bottom_bar_real_add_child (GtkBuildable* base,
                                   GtkBuilder* builder,
                                   GObject* child,
                                   const gchar* type);
static void he_bottom_bar_setup_styling (HeBottomBar* self);
static void he_bottom_bar_setup_layout (HeBottomBar* self);
static GObject * he_bottom_bar_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void he_bottom_bar_finalize (GObject * obj);
static GType he_bottom_bar_get_type_once (void);
static void _vala_he_bottom_bar_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_he_bottom_bar_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_bottom_bar_get_instance_private (HeBottomBar* self)
{
	return G_STRUCT_MEMBER_P (self, HeBottomBar_private_offset);
}

/**
     * Display modes for the BottomBar widget.
     *
     * The mode determines how the bottom bar is positioned and styled:
     *
     * - **DOCKED**: Traditional bottom app bar attached to the window edge.
     * Spans the full width and has a flat appearance with subtle elevation.
     *
     * - **FLOATING**: Overlay bar that hovers over content with rounded corners.
     * Requires an `overlay_widget` to be specified for positioning.
     * Has higher elevation and appears above other content.
     */
static GType
he_bottom_bar_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_MODE_DOCKED, "HE_BOTTOM_BAR_MODE_DOCKED", "docked"}, {HE_BOTTOM_BAR_MODE_FLOATING, "HE_BOTTOM_BAR_MODE_FLOATING", "floating"}, {0, NULL, NULL}};
	GType he_bottom_bar_mode_type_id;
	he_bottom_bar_mode_type_id = g_enum_register_static ("HeBottomBarMode", values);
	return he_bottom_bar_mode_type_id;
}

GType
he_bottom_bar_mode_get_type (void)
{
	static volatile gsize he_bottom_bar_mode_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_mode_type_id__once)) {
		GType he_bottom_bar_mode_type_id;
		he_bottom_bar_mode_type_id = he_bottom_bar_mode_get_type_once ();
		g_once_init_leave (&he_bottom_bar_mode_type_id__once, he_bottom_bar_mode_type_id);
	}
	return he_bottom_bar_mode_type_id__once;
}

/**
     * Positioning options for buttons within the BottomBar.
     *
     * Buttons can be placed on either side of the center content area,
     * allowing for a balanced layout of actions.
     */
static GType
he_bottom_bar_position_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_POSITION_LEFT, "HE_BOTTOM_BAR_POSITION_LEFT", "left"}, {HE_BOTTOM_BAR_POSITION_RIGHT, "HE_BOTTOM_BAR_POSITION_RIGHT", "right"}, {0, NULL, NULL}};
	GType he_bottom_bar_position_type_id;
	he_bottom_bar_position_type_id = g_enum_register_static ("HeBottomBarPosition", values);
	return he_bottom_bar_position_type_id;
}

GType
he_bottom_bar_position_get_type (void)
{
	static volatile gsize he_bottom_bar_position_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_position_type_id__once)) {
		GType he_bottom_bar_position_type_id;
		he_bottom_bar_position_type_id = he_bottom_bar_position_get_type_once ();
		g_once_init_leave (&he_bottom_bar_position_type_id__once, he_bottom_bar_position_type_id);
	}
	return he_bottom_bar_position_type_id__once;
}

const gchar*
he_bottom_bar_get_title (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 59 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 59 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 59 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 59 "../lib/Widgets/BottomBar.vala"
	return result;
#line 173 "BottomBar.c"
}

void
he_bottom_bar_set_title (HeBottomBar* self,
                         const gchar* value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 60 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 61 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 61 "../lib/Widgets/BottomBar.vala"
	gtk_label_set_text (_tmp0_, value);
#line 62 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->title_label;
#line 62 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = strlen (value);
#line 62 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _tmp2_;
#line 62 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp3_ > 0);
#line 60 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY]);
#line 200 "BottomBar.c"
}

const gchar*
he_bottom_bar_get_description (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 72 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->description_label;
#line 72 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 72 "../lib/Widgets/BottomBar.vala"
	result = _tmp1_;
#line 72 "../lib/Widgets/BottomBar.vala"
	return result;
#line 219 "BottomBar.c"
}

void
he_bottom_bar_set_description (HeBottomBar* self,
                               const gchar* value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 73 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 74 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->description_label;
#line 74 "../lib/Widgets/BottomBar.vala"
	gtk_label_set_text (_tmp0_, value);
#line 75 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->description_label;
#line 75 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = strlen (value);
#line 75 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _tmp2_;
#line 75 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp3_ > 0);
#line 73 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY]);
#line 246 "BottomBar.c"
}

HeBottomBarMode
he_bottom_bar_get_mode (HeBottomBar* self)
{
	HeBottomBarMode result;
#line 108 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 108 "../lib/Widgets/BottomBar.vala"
	result = self->priv->_mode;
#line 108 "../lib/Widgets/BottomBar.vala"
	return result;
#line 259 "BottomBar.c"
}

void
he_bottom_bar_set_mode (HeBottomBar* self,
                        HeBottomBarMode value)
{
#line 109 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 110 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_mode == value) {
#line 110 "../lib/Widgets/BottomBar.vala"
		return;
#line 272 "BottomBar.c"
	}
#line 112 "../lib/Widgets/BottomBar.vala"
	self->priv->_mode = value;
#line 113 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_mode_styling (self);
#line 109 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_MODE_PROPERTY]);
#line 280 "BottomBar.c"
}

GtkWidget*
he_bottom_bar_get_overlay_widget (HeBottomBar* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_ = NULL;
	GtkOverlay* _tmp1_;
#line 129 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 129 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->overlay_parent;
#line 129 "../lib/Widgets/BottomBar.vala"
	if (_tmp1_ != NULL) {
#line 295 "BottomBar.c"
		GtkOverlay* _tmp2_;
		GtkWidget* _tmp3_;
#line 129 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->overlay_parent;
#line 129 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = gtk_overlay_get_child (_tmp2_);
#line 129 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp3_;
#line 304 "BottomBar.c"
	} else {
#line 129 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = NULL;
#line 308 "BottomBar.c"
	}
#line 129 "../lib/Widgets/BottomBar.vala"
	result = _tmp0_;
#line 129 "../lib/Widgets/BottomBar.vala"
	return result;
#line 314 "BottomBar.c"
}

void
he_bottom_bar_set_overlay_widget (HeBottomBar* self,
                                  GtkWidget* value)
{
	gboolean _tmp0_ = FALSE;
	HeBottomBarMode _tmp1_;
	HeBottomBarMode _tmp2_;
#line 130 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 131 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = he_bottom_bar_get_mode (self);
#line 131 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = _tmp1_;
#line 131 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_ == HE_BOTTOM_BAR_MODE_FLOATING) {
#line 131 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = value == NULL;
#line 334 "BottomBar.c"
	} else {
#line 131 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = FALSE;
#line 338 "BottomBar.c"
	}
#line 131 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_) {
#line 132 "../lib/Widgets/BottomBar.vala"
		g_warning ("BottomBar.vala:132: overlay_widget must be set when using FLOATING mod" \
"e");
#line 133 "../lib/Widgets/BottomBar.vala"
		return;
#line 346 "BottomBar.c"
	}
#line 136 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_setup_overlay (self, value);
#line 130 "../lib/Widgets/BottomBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY]);
#line 352 "BottomBar.c"
}

/**
     * Add a child widget for Gtk.Builder support.
     *
     * This method is called automatically when using UI files or Blueprint.
     * It only accepts He.Button widgets as children.
     *
     * @param builder The Gtk.Builder instance (unused)
     * @param child The child widget to add (must be He.Button)
     * @param type Positioning hint: "left", "right", or null (defaults to left)
     */
static void
he_bottom_bar_real_add_child (GtkBuildable* base,
                              GtkBuilder* builder,
                              GObject* child,
                              const gchar* type)
{
	HeBottomBar * self;
	HeBottomBarPosition _tmp0_ = 0;
	HeBottomBarPosition position = 0;
#line 161 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) base;
#line 161 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (builder != NULL);
#line 161 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (child != NULL);
#line 162 "../lib/Widgets/BottomBar.vala"
	if (!HE_IS_BUTTON (child)) {
#line 163 "../lib/Widgets/BottomBar.vala"
		g_warning ("BottomBar.vala:163: BottomBar only accepts He.Button children");
#line 164 "../lib/Widgets/BottomBar.vala"
		return;
#line 386 "BottomBar.c"
	}
#line 167 "../lib/Widgets/BottomBar.vala"
	if (g_strcmp0 (type, "right") == 0) {
#line 167 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = HE_BOTTOM_BAR_POSITION_RIGHT;
#line 392 "BottomBar.c"
	} else {
#line 167 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = HE_BOTTOM_BAR_POSITION_LEFT;
#line 396 "BottomBar.c"
	}
#line 167 "../lib/Widgets/BottomBar.vala"
	position = _tmp0_;
#line 168 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_BUTTON, HeButton), position);
#line 402 "BottomBar.c"
}

/**
     * Create a new BottomBar in docked mode.
     *
     * The bottom bar will be created without title or description text.
     * Use the `title` and `description` properties to set content after creation.
     */
HeBottomBar*
he_bottom_bar_construct (GType object_type)
{
	HeBottomBar * self = NULL;
#line 178 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 177 "../lib/Widgets/BottomBar.vala"
	return self;
#line 419 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new (void)
{
#line 177 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct (HE_TYPE_BOTTOM_BAR);
#line 427 "BottomBar.c"
}

/**
     * Create a new BottomBar with title and description text.
     *
     * This is a convenience constructor that sets both the title and description
     * in a single call. The bottom bar will be in docked mode by default.
     *
     * @param title The main title text to display
     * @param description The secondary description text to display
     */
HeBottomBar*
he_bottom_bar_construct_with_details (GType object_type,
                                      const gchar* title,
                                      const gchar* description)
{
	HeBottomBar * self = NULL;
#line 190 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 190 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 191 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 192 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_title (self, title);
#line 193 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_description (self, description);
#line 190 "../lib/Widgets/BottomBar.vala"
	return self;
#line 457 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new_with_details (const gchar* title,
                                const gchar* description)
{
#line 190 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct_with_details (HE_TYPE_BOTTOM_BAR, title, description);
#line 466 "BottomBar.c"
}

/**
     * Create a new BottomBar in floating mode.
     *
     * This convenience constructor automatically sets the mode to FLOATING
     * and configures the overlay widget. The bottom bar will hover over
     * the specified widget with elevated styling.
     *
     * @param overlay_widget The widget to overlay the bottom bar on top of
     */
HeBottomBar*
he_bottom_bar_construct_floating (GType object_type,
                                  GtkWidget* overlay_widget)
{
	HeBottomBar * self = NULL;
#line 205 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (overlay_widget != NULL, NULL);
#line 206 "../lib/Widgets/BottomBar.vala"
	self = (HeBottomBar*) he_bin_construct (object_type);
#line 207 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_mode (self, HE_BOTTOM_BAR_MODE_FLOATING);
#line 208 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_set_overlay_widget (self, overlay_widget);
#line 205 "../lib/Widgets/BottomBar.vala"
	return self;
#line 493 "BottomBar.c"
}

HeBottomBar*
he_bottom_bar_new_floating (GtkWidget* overlay_widget)
{
#line 205 "../lib/Widgets/BottomBar.vala"
	return he_bottom_bar_construct_floating (HE_TYPE_BOTTOM_BAR, overlay_widget);
#line 501 "BottomBar.c"
}

/**
     * Initialize CSS classes and styling properties.
     *
     * Sets up the base styling for title, description, and layout components.
     * Called once during widget construction.
     */
static void
he_bottom_bar_setup_styling (HeBottomBar* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
#line 227 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 228 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->title_label;
#line 228 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "title");
#line 229 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->description_label;
#line 229 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "dim-label");
#line 230 "../lib/Widgets/BottomBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "bottom-bar");
#line 232 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->center_box;
#line 232 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 233 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = self->priv->center_box;
#line 233 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 537 "BottomBar.c"
}

/**
     * Arrange the internal widget hierarchy.
     *
     * Creates the horizontal layout with left, center, and right sections.
     * Called once during widget construction.
     */
static void
he_bottom_bar_setup_layout (HeBottomBar* self)
{
	GtkBox* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkLabel* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
#line 242 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 243 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->center_box;
#line 243 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = self->priv->title_label;
#line 243 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp0_, (GtkWidget*) _tmp1_);
#line 244 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = self->priv->center_box;
#line 244 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = self->priv->description_label;
#line 244 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp2_, (GtkWidget*) _tmp3_);
#line 246 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = self->priv->main_box;
#line 246 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = self->priv->left_box;
#line 246 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp4_, (GtkWidget*) _tmp5_);
#line 247 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = self->priv->main_box;
#line 247 "../lib/Widgets/BottomBar.vala"
	_tmp7_ = self->priv->center_box;
#line 247 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
#line 248 "../lib/Widgets/BottomBar.vala"
	_tmp8_ = self->priv->main_box;
#line 248 "../lib/Widgets/BottomBar.vala"
	_tmp9_ = self->priv->right_box;
#line 248 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
#line 250 "../lib/Widgets/BottomBar.vala"
	_tmp10_ = self->priv->main_box;
#line 250 "../lib/Widgets/BottomBar.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp10_, (GtkWidget*) self);
#line 596 "BottomBar.c"
}

/**
     * Update CSS classes based on current mode.
     *
     * Removes previous mode classes and applies the current mode class.
     * This triggers CSS transitions and styling changes.
     */
static void
he_bottom_bar_update_mode_styling (HeBottomBar* self)
{
#line 259 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 260 "../lib/Widgets/BottomBar.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "docked");
#line 261 "../lib/Widgets/BottomBar.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "floating");
#line 263 "../lib/Widgets/BottomBar.vala"
	if (self->priv->_mode == HE_BOTTOM_BAR_MODE_DOCKED) {
#line 264 "../lib/Widgets/BottomBar.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "docked");
#line 618 "BottomBar.c"
	} else {
#line 266 "../lib/Widgets/BottomBar.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "floating");
#line 622 "BottomBar.c"
	}
}

/**
     * Configure overlay positioning for floating mode.
     *
     * Creates or uses an existing Gtk.Overlay to position the bottom bar
     * over the target widget. Handles widget reparenting automatically.
     *
     * @param target_widget The widget to overlay, or null to clear overlay
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 290 "../lib/Widgets/BottomBar.vala"
	return self ? g_object_ref (self) : NULL;
#line 639 "BottomBar.c"
}

static void
he_bottom_bar_setup_overlay (HeBottomBar* self,
                             GtkWidget* target_widget)
{
	GtkOverlay* _tmp0_;
	HeBottomBarMode _tmp2_;
	HeBottomBarMode _tmp3_;
#line 278 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 279 "../lib/Widgets/BottomBar.vala"
	if (target_widget == NULL) {
#line 279 "../lib/Widgets/BottomBar.vala"
		return;
#line 655 "BottomBar.c"
	}
#line 282 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = self->priv->overlay_parent;
#line 282 "../lib/Widgets/BottomBar.vala"
	if (_tmp0_ != NULL) {
#line 661 "BottomBar.c"
		GtkOverlay* _tmp1_;
#line 283 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->overlay_parent;
#line 283 "../lib/Widgets/BottomBar.vala"
		gtk_overlay_set_child (_tmp1_, NULL);
#line 284 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (self->priv->overlay_parent);
#line 284 "../lib/Widgets/BottomBar.vala"
		self->priv->overlay_parent = NULL;
#line 671 "BottomBar.c"
	}
#line 287 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = he_bottom_bar_get_mode (self);
#line 287 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _tmp2_;
#line 287 "../lib/Widgets/BottomBar.vala"
	if (_tmp3_ == HE_BOTTOM_BAR_MODE_FLOATING) {
#line 679 "BottomBar.c"
		GtkOverlay* _tmp19_;
#line 289 "../lib/Widgets/BottomBar.vala"
		if (!G_TYPE_CHECK_INSTANCE_TYPE (target_widget, gtk_overlay_get_type ())) {
#line 683 "BottomBar.c"
			GtkWidget* parent = NULL;
			GtkWidget* _tmp4_;
			GtkWidget* _tmp5_;
			GtkWidget* _tmp6_;
#line 290 "../lib/Widgets/BottomBar.vala"
			_tmp4_ = gtk_widget_get_parent (target_widget);
#line 290 "../lib/Widgets/BottomBar.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 290 "../lib/Widgets/BottomBar.vala"
			parent = _tmp5_;
#line 291 "../lib/Widgets/BottomBar.vala"
			_tmp6_ = parent;
#line 291 "../lib/Widgets/BottomBar.vala"
			if (_tmp6_ != NULL) {
#line 698 "BottomBar.c"
				GtkOverlay* _tmp7_;
				GtkOverlay* _tmp8_;
				GtkWidget* _tmp9_;
#line 292 "../lib/Widgets/BottomBar.vala"
				_tmp7_ = (GtkOverlay*) gtk_overlay_new ();
#line 292 "../lib/Widgets/BottomBar.vala"
				g_object_ref_sink (_tmp7_);
#line 292 "../lib/Widgets/BottomBar.vala"
				_g_object_unref0 (self->priv->overlay_parent);
#line 292 "../lib/Widgets/BottomBar.vala"
				self->priv->overlay_parent = _tmp7_;
#line 294 "../lib/Widgets/BottomBar.vala"
				gtk_widget_unparent (target_widget);
#line 295 "../lib/Widgets/BottomBar.vala"
				_tmp8_ = self->priv->overlay_parent;
#line 295 "../lib/Widgets/BottomBar.vala"
				gtk_overlay_set_child (_tmp8_, target_widget);
#line 297 "../lib/Widgets/BottomBar.vala"
				_tmp9_ = parent;
#line 297 "../lib/Widgets/BottomBar.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_box_get_type ())) {
#line 720 "BottomBar.c"
					GtkWidget* _tmp10_;
					GtkOverlay* _tmp11_;
#line 298 "../lib/Widgets/BottomBar.vala"
					_tmp10_ = parent;
#line 298 "../lib/Widgets/BottomBar.vala"
					_tmp11_ = self->priv->overlay_parent;
#line 298 "../lib/Widgets/BottomBar.vala"
					gtk_box_append (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_box_get_type (), GtkBox), (GtkWidget*) _tmp11_);
#line 729 "BottomBar.c"
				} else {
					GtkWidget* _tmp12_;
#line 299 "../lib/Widgets/BottomBar.vala"
					_tmp12_ = parent;
#line 299 "../lib/Widgets/BottomBar.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_window_get_type ())) {
#line 736 "BottomBar.c"
						GtkWidget* _tmp13_;
						GtkOverlay* _tmp14_;
#line 300 "../lib/Widgets/BottomBar.vala"
						_tmp13_ = parent;
#line 300 "../lib/Widgets/BottomBar.vala"
						_tmp14_ = self->priv->overlay_parent;
#line 300 "../lib/Widgets/BottomBar.vala"
						gtk_window_set_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_window_get_type (), GtkWindow), (GtkWidget*) _tmp14_);
#line 745 "BottomBar.c"
					} else {
						GtkWidget* _tmp15_;
#line 301 "../lib/Widgets/BottomBar.vala"
						_tmp15_ = parent;
#line 301 "../lib/Widgets/BottomBar.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, gtk_revealer_get_type ())) {
#line 752 "BottomBar.c"
							GtkWidget* _tmp16_;
							GtkOverlay* _tmp17_;
#line 302 "../lib/Widgets/BottomBar.vala"
							_tmp16_ = parent;
#line 302 "../lib/Widgets/BottomBar.vala"
							_tmp17_ = self->priv->overlay_parent;
#line 302 "../lib/Widgets/BottomBar.vala"
							gtk_revealer_set_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_revealer_get_type (), GtkRevealer), (GtkWidget*) _tmp17_);
#line 761 "BottomBar.c"
						}
					}
				}
			}
#line 289 "../lib/Widgets/BottomBar.vala"
			_g_object_unref0 (parent);
#line 768 "BottomBar.c"
		} else {
			GtkOverlay* _tmp18_;
#line 306 "../lib/Widgets/BottomBar.vala"
			_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (target_widget, gtk_overlay_get_type (), GtkOverlay));
#line 306 "../lib/Widgets/BottomBar.vala"
			_g_object_unref0 (self->priv->overlay_parent);
#line 306 "../lib/Widgets/BottomBar.vala"
			self->priv->overlay_parent = _tmp18_;
#line 777 "BottomBar.c"
		}
#line 309 "../lib/Widgets/BottomBar.vala"
		_tmp19_ = self->priv->overlay_parent;
#line 309 "../lib/Widgets/BottomBar.vala"
		if (_tmp19_ != NULL) {
#line 783 "BottomBar.c"
			GtkOverlay* _tmp20_;
#line 310 "../lib/Widgets/BottomBar.vala"
			_tmp20_ = self->priv->overlay_parent;
#line 310 "../lib/Widgets/BottomBar.vala"
			gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) self);
#line 311 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 312 "../lib/Widgets/BottomBar.vala"
			gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
#line 793 "BottomBar.c"
		}
	}
}

/**
     * Add a button to the end of the bottom bar.
     *
     * The button is added to the specified position (left or right side)
     * after any existing buttons in that position.
     *
     * @param button The He.Button to add to the bottom bar
     * @param position Which side of the bar to add the button to
     *
     */
void
he_bottom_bar_append_button (HeBottomBar* self,
                             HeButton* button,
                             HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
#line 327 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 327 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 328 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 822 "BottomBar.c"
		GtkBox* _tmp1_;
#line 328 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 328 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 828 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 328 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 328 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 835 "BottomBar.c"
	}
#line 328 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 328 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 329 "../lib/Widgets/BottomBar.vala"
	gtk_box_append (target_box, (GtkWidget*) button);
#line 327 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 845 "BottomBar.c"
}

/**
     * Add a button to the beginning of the bottom bar.
     *
     * The button is added to the specified position (left or right side)
     * before any existing buttons in that position.
     *
     * @param button The He.Button to add to the bottom bar
     * @param position Which side of the bar to add the button to
     *
     */
void
he_bottom_bar_prepend_button (HeBottomBar* self,
                              HeButton* button,
                              HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
#line 342 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 342 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 343 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 872 "BottomBar.c"
		GtkBox* _tmp1_;
#line 343 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 343 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 878 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 343 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 343 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 885 "BottomBar.c"
	}
#line 343 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 343 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 344 "../lib/Widgets/BottomBar.vala"
	gtk_box_prepend (target_box, (GtkWidget*) button);
#line 342 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 895 "BottomBar.c"
}

/**
     * Remove a button from the bottom bar.
     *
     * The button is removed from whichever position it's currently in.
     * If the button is not a child of this bottom bar, no action is taken.
     *
     * @param button The He.Button to remove from the bottom bar
     *
     */
void
he_bottom_bar_remove_button (HeBottomBar* self,
                             HeButton* button)
{
	GtkWidget* parent = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_;
#line 356 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 356 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 357 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) button);
#line 357 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 357 "../lib/Widgets/BottomBar.vala"
	parent = _tmp1_;
#line 358 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = parent;
#line 358 "../lib/Widgets/BottomBar.vala"
	if (_tmp3_ != NULL) {
#line 930 "BottomBar.c"
		gboolean _tmp4_ = FALSE;
		GtkWidget* _tmp5_;
		GtkBox* _tmp6_;
#line 358 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = parent;
#line 358 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->left_box;
#line 358 "../lib/Widgets/BottomBar.vala"
		if (_tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
#line 358 "../lib/Widgets/BottomBar.vala"
			_tmp4_ = TRUE;
#line 942 "BottomBar.c"
		} else {
			GtkWidget* _tmp7_;
			GtkBox* _tmp8_;
#line 358 "../lib/Widgets/BottomBar.vala"
			_tmp7_ = parent;
#line 358 "../lib/Widgets/BottomBar.vala"
			_tmp8_ = self->priv->right_box;
#line 358 "../lib/Widgets/BottomBar.vala"
			_tmp4_ = _tmp7_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget);
#line 952 "BottomBar.c"
		}
#line 358 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _tmp4_;
#line 956 "BottomBar.c"
	} else {
#line 358 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = FALSE;
#line 960 "BottomBar.c"
	}
#line 358 "../lib/Widgets/BottomBar.vala"
	if (_tmp2_) {
#line 964 "BottomBar.c"
		GtkWidget* _tmp9_;
#line 359 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = parent;
#line 359 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_box_get_type (), GtkBox), (GtkWidget*) button);
#line 970 "BottomBar.c"
	}
#line 356 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (parent);
#line 974 "BottomBar.c"
}

/**
     * Insert a button after another button.
     *
     * The new button is inserted immediately after the reference button
     * in the specified position. Both buttons must be in the same position.
     *
     * @param button The He.Button to insert
     * @param after The existing He.Button to insert after
     * @param position Which side of the bar to insert the button into
     *
     */
void
he_bottom_bar_insert_button_after (HeBottomBar* self,
                                   HeButton* button,
                                   HeButton* after,
                                   HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
#line 374 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 374 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (button != NULL);
#line 374 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (after != NULL);
#line 375 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 1005 "BottomBar.c"
		GtkBox* _tmp1_;
#line 375 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 375 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 1011 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 375 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 375 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 1018 "BottomBar.c"
	}
#line 375 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 375 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 376 "../lib/Widgets/BottomBar.vala"
	gtk_box_insert_child_after (target_box, (GtkWidget*) button, (GtkWidget*) after);
#line 374 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 1028 "BottomBar.c"
}

/**
     * Remove all buttons from the bottom bar.
     *
     * This removes all buttons from both the left and right sides of the bar.
     * The buttons are unparented but not destroyed, so they can be reused.
     *
     */
void
he_bottom_bar_clear_buttons (HeBottomBar* self)
{
	GtkWidget* child = NULL;
#line 386 "../lib/Widgets/BottomBar.vala"
	g_return_if_fail (self != NULL);
#line 389 "../lib/Widgets/BottomBar.vala"
	while (TRUE) {
#line 1046 "BottomBar.c"
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkBox* _tmp4_;
		GtkWidget* _tmp5_;
#line 389 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = self->priv->left_box;
#line 389 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 389 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 389 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (child);
#line 389 "../lib/Widgets/BottomBar.vala"
		child = _tmp2_;
#line 389 "../lib/Widgets/BottomBar.vala"
		_tmp3_ = child;
#line 389 "../lib/Widgets/BottomBar.vala"
		if (!(_tmp3_ != NULL)) {
#line 389 "../lib/Widgets/BottomBar.vala"
			break;
#line 1069 "BottomBar.c"
		}
#line 390 "../lib/Widgets/BottomBar.vala"
		_tmp4_ = self->priv->left_box;
#line 390 "../lib/Widgets/BottomBar.vala"
		_tmp5_ = child;
#line 390 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp4_, _tmp5_);
#line 1077 "BottomBar.c"
	}
#line 393 "../lib/Widgets/BottomBar.vala"
	while (TRUE) {
#line 1081 "BottomBar.c"
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
		GtkBox* _tmp10_;
		GtkWidget* _tmp11_;
#line 393 "../lib/Widgets/BottomBar.vala"
		_tmp6_ = self->priv->right_box;
#line 393 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = gtk_widget_get_first_child ((GtkWidget*) _tmp6_);
#line 393 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 393 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (child);
#line 393 "../lib/Widgets/BottomBar.vala"
		child = _tmp8_;
#line 393 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = child;
#line 393 "../lib/Widgets/BottomBar.vala"
		if (!(_tmp9_ != NULL)) {
#line 393 "../lib/Widgets/BottomBar.vala"
			break;
#line 1104 "BottomBar.c"
		}
#line 394 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = self->priv->right_box;
#line 394 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = child;
#line 394 "../lib/Widgets/BottomBar.vala"
		gtk_box_remove (_tmp10_, _tmp11_);
#line 1112 "BottomBar.c"
	}
#line 386 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (child);
#line 1116 "BottomBar.c"
}

/**
     * Get the number of buttons in a specific position.
     *
     * This counts all He.Button widgets currently added to the specified
     * side of the bottom bar.
     *
     * @param position Which side of the bar to count buttons for
     * @return The number of buttons in the specified position
     *
     */
gint
he_bottom_bar_get_button_count (HeBottomBar* self,
                                HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* target_box = NULL;
	GtkBox* _tmp3_;
	gint count = 0;
	GtkWidget* child = NULL;
	GtkBox* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	gint result;
#line 408 "../lib/Widgets/BottomBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 409 "../lib/Widgets/BottomBar.vala"
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
#line 1146 "BottomBar.c"
		GtkBox* _tmp1_;
#line 409 "../lib/Widgets/BottomBar.vala"
		_tmp1_ = self->priv->left_box;
#line 409 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp1_;
#line 1152 "BottomBar.c"
	} else {
		GtkBox* _tmp2_;
#line 409 "../lib/Widgets/BottomBar.vala"
		_tmp2_ = self->priv->right_box;
#line 409 "../lib/Widgets/BottomBar.vala"
		_tmp0_ = _tmp2_;
#line 1159 "BottomBar.c"
	}
#line 409 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 409 "../lib/Widgets/BottomBar.vala"
	target_box = _tmp3_;
#line 410 "../lib/Widgets/BottomBar.vala"
	count = 0;
#line 412 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = target_box;
#line 412 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = gtk_widget_get_first_child ((GtkWidget*) _tmp4_);
#line 412 "../lib/Widgets/BottomBar.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 412 "../lib/Widgets/BottomBar.vala"
	child = _tmp6_;
#line 413 "../lib/Widgets/BottomBar.vala"
	while (TRUE) {
#line 1177 "BottomBar.c"
		GtkWidget* _tmp7_;
		gint _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
#line 413 "../lib/Widgets/BottomBar.vala"
		_tmp7_ = child;
#line 413 "../lib/Widgets/BottomBar.vala"
		if (!(_tmp7_ != NULL)) {
#line 413 "../lib/Widgets/BottomBar.vala"
			break;
#line 1189 "BottomBar.c"
		}
#line 414 "../lib/Widgets/BottomBar.vala"
		_tmp8_ = count;
#line 414 "../lib/Widgets/BottomBar.vala"
		count = _tmp8_ + 1;
#line 415 "../lib/Widgets/BottomBar.vala"
		_tmp9_ = child;
#line 415 "../lib/Widgets/BottomBar.vala"
		_tmp10_ = gtk_widget_get_next_sibling (_tmp9_);
#line 415 "../lib/Widgets/BottomBar.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 415 "../lib/Widgets/BottomBar.vala"
		_g_object_unref0 (child);
#line 415 "../lib/Widgets/BottomBar.vala"
		child = _tmp11_;
#line 1205 "BottomBar.c"
	}
#line 418 "../lib/Widgets/BottomBar.vala"
	result = count;
#line 418 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (child);
#line 418 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (target_box);
#line 418 "../lib/Widgets/BottomBar.vala"
	return result;
#line 1215 "BottomBar.c"
}

static GObject *
he_bottom_bar_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeBottomBar * self;
#line 215 "../lib/Widgets/BottomBar.vala"
	parent_class = G_OBJECT_CLASS (he_bottom_bar_parent_class);
#line 215 "../lib/Widgets/BottomBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 215 "../lib/Widgets/BottomBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 216 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_setup_styling (self);
#line 217 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_setup_layout (self);
#line 218 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_update_mode_styling (self);
#line 215 "../lib/Widgets/BottomBar.vala"
	return obj;
#line 1240 "BottomBar.c"
}

static void
he_bottom_bar_class_init (HeBottomBarClass * klass,
                          gpointer klass_data)
{
#line 42 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_parent_class = g_type_class_peek_parent (klass);
#line 42 "../lib/Widgets/BottomBar.vala"
	g_type_class_adjust_private_offset (klass, &HeBottomBar_private_offset);
#line 42 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_bottom_bar_get_property;
#line 42 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_bottom_bar_set_property;
#line 42 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->constructor = he_bottom_bar_constructor;
#line 42 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (klass)->finalize = he_bottom_bar_finalize;
#line 1259 "BottomBar.c"
	/**
	     * The main title text displayed in the center of the bottom bar.
	     * This is ideal for showing the current context or selection state,
	     * such as "Photos" or "3 items selected".
	     */
#line 42 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_TITLE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1267 "BottomBar.c"
	/**
	     * The secondary description text displayed below the title.
	     * This is ideal for showing additional context or action hints,
	     * such as "Tap to select items" or "Ready to share".
	     */
#line 42 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_DESCRIPTION_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1275 "BottomBar.c"
	/**
	     * The current display mode of the bottom bar.
	     *
	     * Changing this property automatically updates the CSS classes and positioning.
	     * When switching to FLOATING mode, ensure `overlay_widget` is set.
	     *
	     * CSS Classes
	     * - `docked` class is applied when mode is DOCKED
	     * - `floating` class is applied when mode is FLOATING
	     */
#line 42 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_MODE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", HE_BOTTOM_BAR_TYPE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1288 "BottomBar.c"
	/**
	     * The widget to overlay when in floating mode.
	     *
	     * This property is **required** when using FLOATING mode. The bottom bar
	     * will be positioned as an overlay on top of this widget.
	     *
	     * Behavior
	     * - If the target widget is not already in a Gtk.Overlay, one will be created automatically
	     * - The overlay is inserted into the widget hierarchy, preserving the original structure
	     * - Setting this to `null` while in FLOATING mode will show a warning
	     */
#line 42 "../lib/Widgets/BottomBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY] = g_param_spec_object ("overlay-widget", "overlay-widget", "overlay-widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 212 "../lib/Widgets/BottomBar.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 1304 "BottomBar.c"
}

static void
he_bottom_bar_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                            gpointer iface_data)
{
#line 42 "../lib/Widgets/BottomBar.vala"
	he_bottom_bar_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 42 "../lib/Widgets/BottomBar.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_bottom_bar_real_add_child;
#line 1315 "BottomBar.c"
}

static void
he_bottom_bar_instance_init (HeBottomBar * self,
                             gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
#line 42 "../lib/Widgets/BottomBar.vala"
	self->priv = he_bottom_bar_get_instance_private (self);
#line 43 "../lib/Widgets/BottomBar.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 43 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp0_);
#line 43 "../lib/Widgets/BottomBar.vala"
	self->priv->main_box = _tmp0_;
#line 44 "../lib/Widgets/BottomBar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 4);
#line 44 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp1_);
#line 44 "../lib/Widgets/BottomBar.vala"
	self->priv->left_box = _tmp1_;
#line 45 "../lib/Widgets/BottomBar.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 45 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp2_);
#line 45 "../lib/Widgets/BottomBar.vala"
	self->priv->center_box = _tmp2_;
#line 46 "../lib/Widgets/BottomBar.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 4);
#line 46 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp3_);
#line 46 "../lib/Widgets/BottomBar.vala"
	self->priv->right_box = _tmp3_;
#line 48 "../lib/Widgets/BottomBar.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 48 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp4_);
#line 48 "../lib/Widgets/BottomBar.vala"
	self->priv->title_label = _tmp4_;
#line 49 "../lib/Widgets/BottomBar.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new ("");
#line 49 "../lib/Widgets/BottomBar.vala"
	g_object_ref_sink (_tmp5_);
#line 49 "../lib/Widgets/BottomBar.vala"
	self->priv->description_label = _tmp5_;
#line 51 "../lib/Widgets/BottomBar.vala"
	self->priv->overlay_parent = NULL;
#line 96 "../lib/Widgets/BottomBar.vala"
	self->priv->_mode = HE_BOTTOM_BAR_MODE_DOCKED;
#line 1370 "BottomBar.c"
}

static void
he_bottom_bar_finalize (GObject * obj)
{
	HeBottomBar * self;
#line 42 "../lib/Widgets/BottomBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 43 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->main_box);
#line 44 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->left_box);
#line 45 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->center_box);
#line 46 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->right_box);
#line 48 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->title_label);
#line 49 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->description_label);
#line 51 "../lib/Widgets/BottomBar.vala"
	_g_object_unref0 (self->priv->overlay_parent);
#line 42 "../lib/Widgets/BottomBar.vala"
	G_OBJECT_CLASS (he_bottom_bar_parent_class)->finalize (obj);
#line 1395 "BottomBar.c"
}

/**
 * A BottomBar is a bottom toolbar that displays actions and content labels.
 *
 * The BottomBar can operate in two distinct modes:
 * - **Docked Mode**: Acts as a traditional bottom app bar, attached to the window edge
 * - **Floating Mode**: Hovers over content as an overlay with rounded corners and elevation
 *
 * Important Notes
 *
 * - **Button Limitation**: Only accepts `He.Button` widgets as children
 * - **Floating Mode Requirements**: Must set `overlay_widget` when using `Mode.FLOATING`
 * - **Automatic Overlay Creation**: If the target widget isn't in a `Gtk.Overlay`, one is created automatically
 *
 * CSS Classes
 *
 * The BottomBar automatically applies CSS classes for styling:
 * - `bottom-bar`: Always applied to the root element
 * - `docked`: Applied when in docked mode
 * - `floating`: Applied when in floating mode
 *
 * @since 1.0
 */
static GType
he_bottom_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeBottomBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_bottom_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeBottomBar), 0, (GInstanceInitFunc) he_bottom_bar_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_bottom_bar_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_bottom_bar_type_id;
	he_bottom_bar_type_id = g_type_register_static (HE_TYPE_BIN, "HeBottomBar", &g_define_type_info, 0);
	g_type_add_interface_static (he_bottom_bar_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeBottomBar_private_offset = g_type_add_instance_private (he_bottom_bar_type_id, sizeof (HeBottomBarPrivate));
	return he_bottom_bar_type_id;
}

GType
he_bottom_bar_get_type (void)
{
	static volatile gsize he_bottom_bar_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_type_id__once)) {
		GType he_bottom_bar_type_id;
		he_bottom_bar_type_id = he_bottom_bar_get_type_once ();
		g_once_init_leave (&he_bottom_bar_type_id__once, he_bottom_bar_type_id);
	}
	return he_bottom_bar_type_id__once;
}

static void
_vala_he_bottom_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 42 "../lib/Widgets/BottomBar.vala"
	switch (property_id) {
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		g_value_set_string (value, he_bottom_bar_get_title (self));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		g_value_set_string (value, he_bottom_bar_get_description (self));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_MODE_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		g_value_set_enum (value, he_bottom_bar_get_mode (self));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		g_value_set_object (value, he_bottom_bar_get_overlay_widget (self));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 1478 "BottomBar.c"
		default:
#line 42 "../lib/Widgets/BottomBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 1484 "BottomBar.c"
	}
}

static void
_vala_he_bottom_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
#line 42 "../lib/Widgets/BottomBar.vala"
	switch (property_id) {
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_title (self, g_value_get_string (value));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_description (self, g_value_get_string (value));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_MODE_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_mode (self, g_value_get_enum (value));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 42 "../lib/Widgets/BottomBar.vala"
		case HE_BOTTOM_BAR_OVERLAY_WIDGET_PROPERTY:
#line 42 "../lib/Widgets/BottomBar.vala"
		he_bottom_bar_set_overlay_widget (self, g_value_get_object (value));
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 1522 "BottomBar.c"
		default:
#line 42 "../lib/Widgets/BottomBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../lib/Widgets/BottomBar.vala"
		break;
#line 1528 "BottomBar.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

