/* ProgressBar.c generated by valac 0.56.17, the Vala compiler
 * generated from ProgressBar.vala, do not modify */

/*
 * Copyright (c) 2024-2025 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>

#define HE_PROGRESS_BAR_FLATTEN_DURATION ((gint64) 200000)
#define HE_PROGRESS_BAR_PROGRESS_MARGIN 4
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_PROGRESS_BAR_0_PROPERTY,
	HE_PROGRESS_BAR_WAVE_AMPLITUDE_PROPERTY,
	HE_PROGRESS_BAR_WAVE_WAVELENGTH_PROPERTY,
	HE_PROGRESS_BAR_WAVE_THICKNESS_PROPERTY,
	HE_PROGRESS_BAR_ANIMATE_PROPERTY,
	HE_PROGRESS_BAR_PROGRESS_PROPERTY,
	HE_PROGRESS_BAR_STOP_INDICATOR_VISIBILITY_PROPERTY,
	HE_PROGRESS_BAR_IS_OSD_PROPERTY,
	HE_PROGRESS_BAR_IS_WAVY_PROPERTY,
	HE_PROGRESS_BAR_NUM_PROPERTIES
};
static GParamSpec* he_progress_bar_properties[HE_PROGRESS_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _he_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_rgb_color_free (var), NULL)))

struct _HeProgressBarPrivate {
	GtkBox* main_box;
	GtkBox* stop_indicator;
	GtkOverlay* pb_overlay;
	HeDesktop* desktop;
	gboolean is_dark;
	GdkRGBA accent_color;
	GtkDrawingArea* wavy_drawing_area;
	gint _wave_amplitude;
	gint _wave_wavelength;
	gint _wave_thickness;
	gdouble _wave_phase;
	guint _animation_tick_id;
	gboolean _continuous_animation;
	gboolean _is_flattening;
	gint64 _flatten_start_time;
	gboolean _animate;
	gdouble _progress;
	gboolean _stop_indicator_visibility;
	gboolean _is_osd;
	gboolean _is_wavy;
};

static gint HeProgressBar_private_offset;
static gpointer he_progress_bar_parent_class = NULL;
static GtkBuildableIface * he_progress_bar_gtk_buildable_parent_iface = NULL;

static gboolean he_progress_bar_on_animation_tick (HeProgressBar* self,
                                            GtkWidget* widget,
                                            GdkFrameClock* frame_clock);
static gboolean _he_progress_bar_on_animation_tick_gtk_tick_callback (GtkWidget* widget,
                                                               GdkFrameClock* frame_clock,
                                                               gpointer self);
static void he_progress_bar_update_stop_indicator_position (HeProgressBar* self);
static void he_progress_bar_start_continuous_animation (HeProgressBar* self);
static void he_progress_bar_stop_continuous_animation (HeProgressBar* self);
static HeApplication* he_progress_bar_get_he_application (HeProgressBar* self);
static void he_progress_bar_update_accent_color (HeProgressBar* self);
static void he_progress_bar_draw_wavy_progress (HeProgressBar* self,
                                         GtkDrawingArea* area,
                                         cairo_t* cr,
                                         gint width,
                                         gint height);
static GObject * he_progress_bar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _he_progress_bar_draw_wavy_progress_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void _he_progress_bar_update_accent_color_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void _he_progress_bar___lambda138_ (HeProgressBar* self);
static void _he_progress_bar_update_accent_color_he_application_accent_color_changed (HeApplication* _sender,
                                                                               gpointer self);
static void __he_progress_bar___lambda138__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void he_progress_bar_finalize (GObject * obj);
static GType he_progress_bar_get_type_once (void);
static void _vala_he_progress_bar_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_progress_bar_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_progress_bar_get_instance_private (HeProgressBar* self)
{
	return G_STRUCT_MEMBER_P (self, HeProgressBar_private_offset);
}

gint
he_progress_bar_get_wave_amplitude (HeProgressBar* self)
{
	gint result;
#line 48 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_wave_amplitude;
#line 48 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 151 "ProgressBar.c"
}

void
he_progress_bar_set_wave_amplitude (HeProgressBar* self,
                                    gint value)
{
	GtkDrawingArea* _tmp0_;
#line 49 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 50 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_amplitude = (gint) fmax ((gdouble) 1, (gdouble) value);
#line 51 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 51 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 49 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_WAVE_AMPLITUDE_PROPERTY]);
#line 169 "ProgressBar.c"
}

gint
he_progress_bar_get_wave_wavelength (HeProgressBar* self)
{
	gint result;
#line 60 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_wave_wavelength;
#line 60 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 182 "ProgressBar.c"
}

void
he_progress_bar_set_wave_wavelength (HeProgressBar* self,
                                     gint value)
{
	GtkDrawingArea* _tmp0_;
#line 61 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 62 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_wavelength = (gint) fmax ((gdouble) 5, (gdouble) value);
#line 63 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 63 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 61 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_WAVE_WAVELENGTH_PROPERTY]);
#line 200 "ProgressBar.c"
}

gint
he_progress_bar_get_wave_thickness (HeProgressBar* self)
{
	gint result;
#line 72 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_wave_thickness;
#line 72 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 213 "ProgressBar.c"
}

void
he_progress_bar_set_wave_thickness (HeProgressBar* self,
                                    gint value)
{
	GtkDrawingArea* _tmp0_;
#line 73 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 74 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_thickness = (gint) fmax ((gdouble) 1, (gdouble) value);
#line 75 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = self->priv->wavy_drawing_area;
#line 75 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 73 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_WAVE_THICKNESS_PROPERTY]);
#line 231 "ProgressBar.c"
}

gboolean
he_progress_bar_get_animate (HeProgressBar* self)
{
	gboolean result;
#line 103 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_animate;
#line 103 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 244 "ProgressBar.c"
}

static gboolean
_he_progress_bar_on_animation_tick_gtk_tick_callback (GtkWidget* widget,
                                                      GdkFrameClock* frame_clock,
                                                      gpointer self)
{
	gboolean result;
	result = he_progress_bar_on_animation_tick ((HeProgressBar*) self, widget, frame_clock);
#line 108 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 256 "ProgressBar.c"
}

void
he_progress_bar_set_animate (HeProgressBar* self,
                             gboolean value)
{
#line 104 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 105 "../lib/Widgets/ProgressBar.vala"
	self->priv->_animate = value;
#line 106 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_is_wavy) {
#line 269 "ProgressBar.c"
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
#line 107 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_animate) {
#line 107 "../lib/Widgets/ProgressBar.vala"
			_tmp1_ = self->priv->_continuous_animation;
#line 276 "ProgressBar.c"
		} else {
#line 107 "../lib/Widgets/ProgressBar.vala"
			_tmp1_ = FALSE;
#line 280 "ProgressBar.c"
		}
#line 107 "../lib/Widgets/ProgressBar.vala"
		if (_tmp1_) {
#line 107 "../lib/Widgets/ProgressBar.vala"
			_tmp0_ = self->priv->_animation_tick_id == ((guint) 0);
#line 286 "ProgressBar.c"
		} else {
#line 107 "../lib/Widgets/ProgressBar.vala"
			_tmp0_ = FALSE;
#line 290 "ProgressBar.c"
		}
#line 107 "../lib/Widgets/ProgressBar.vala"
		if (_tmp0_) {
#line 294 "ProgressBar.c"
			GtkDrawingArea* _tmp2_;
#line 108 "../lib/Widgets/ProgressBar.vala"
			_tmp2_ = self->priv->wavy_drawing_area;
#line 108 "../lib/Widgets/ProgressBar.vala"
			self->priv->_animation_tick_id = gtk_widget_add_tick_callback ((GtkWidget*) _tmp2_, _he_progress_bar_on_animation_tick_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 300 "ProgressBar.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 109 "../lib/Widgets/ProgressBar.vala"
			if (!self->priv->_animate) {
#line 109 "../lib/Widgets/ProgressBar.vala"
				_tmp3_ = self->priv->_animation_tick_id != ((guint) 0);
#line 307 "ProgressBar.c"
			} else {
#line 109 "../lib/Widgets/ProgressBar.vala"
				_tmp3_ = FALSE;
#line 311 "ProgressBar.c"
			}
#line 109 "../lib/Widgets/ProgressBar.vala"
			if (_tmp3_) {
#line 315 "ProgressBar.c"
				GtkDrawingArea* _tmp4_;
#line 110 "../lib/Widgets/ProgressBar.vala"
				_tmp4_ = self->priv->wavy_drawing_area;
#line 110 "../lib/Widgets/ProgressBar.vala"
				gtk_widget_remove_tick_callback ((GtkWidget*) _tmp4_, self->priv->_animation_tick_id);
#line 111 "../lib/Widgets/ProgressBar.vala"
				self->priv->_animation_tick_id = (guint) 0;
#line 323 "ProgressBar.c"
			}
		}
	}
#line 104 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_ANIMATE_PROPERTY]);
#line 329 "ProgressBar.c"
}

gdouble
he_progress_bar_get_progress (HeProgressBar* self)
{
	gdouble result;
#line 122 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 123 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_progress;
#line 123 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 342 "ProgressBar.c"
}

void
he_progress_bar_set_progress (HeProgressBar* self,
                              gdouble value)
{
	gdouble old_progress = 0.0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 125 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 126 "../lib/Widgets/ProgressBar.vala"
	old_progress = self->priv->_progress;
#line 127 "../lib/Widgets/ProgressBar.vala"
	self->priv->_progress = fmax (0.0, fmin (1.0, value));
#line 130 "../lib/Widgets/ProgressBar.vala"
	if (old_progress < 0.9) {
#line 130 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = self->priv->_progress >= 0.9;
#line 362 "ProgressBar.c"
	} else {
#line 130 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = FALSE;
#line 366 "ProgressBar.c"
	}
#line 130 "../lib/Widgets/ProgressBar.vala"
	if (_tmp1_) {
#line 130 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = !self->priv->_is_flattening;
#line 372 "ProgressBar.c"
	} else {
#line 130 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = FALSE;
#line 376 "ProgressBar.c"
	}
#line 130 "../lib/Widgets/ProgressBar.vala"
	if (_tmp0_) {
#line 131 "../lib/Widgets/ProgressBar.vala"
		self->priv->_is_flattening = TRUE;
#line 132 "../lib/Widgets/ProgressBar.vala"
		self->priv->_flatten_start_time = g_get_monotonic_time ();
#line 384 "ProgressBar.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 135 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_progress < 0.9) {
#line 135 "../lib/Widgets/ProgressBar.vala"
			_tmp2_ = self->priv->_is_flattening;
#line 391 "ProgressBar.c"
		} else {
#line 135 "../lib/Widgets/ProgressBar.vala"
			_tmp2_ = FALSE;
#line 395 "ProgressBar.c"
		}
#line 135 "../lib/Widgets/ProgressBar.vala"
		if (_tmp2_) {
#line 136 "../lib/Widgets/ProgressBar.vala"
			self->priv->_is_flattening = FALSE;
#line 401 "ProgressBar.c"
		}
	}
#line 139 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_is_wavy) {
#line 406 "ProgressBar.c"
		GtkDrawingArea* _tmp3_;
#line 140 "../lib/Widgets/ProgressBar.vala"
		_tmp3_ = self->priv->wavy_drawing_area;
#line 140 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
#line 141 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_update_stop_indicator_position (self);
#line 414 "ProgressBar.c"
	} else {
		GtkProgressBar* _tmp4_;
#line 143 "../lib/Widgets/ProgressBar.vala"
		_tmp4_ = self->progressbar;
#line 143 "../lib/Widgets/ProgressBar.vala"
		gtk_progress_bar_set_fraction (_tmp4_, self->priv->_progress);
#line 421 "ProgressBar.c"
	}
#line 125 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_PROGRESS_PROPERTY]);
#line 425 "ProgressBar.c"
}

gboolean
he_progress_bar_get_stop_indicator_visibility (HeProgressBar* self)
{
	gboolean result;
#line 153 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_stop_indicator_visibility;
#line 154 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 438 "ProgressBar.c"
}

void
he_progress_bar_set_stop_indicator_visibility (HeProgressBar* self,
                                               gboolean value)
{
#line 156 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 157 "../lib/Widgets/ProgressBar.vala"
	self->priv->_stop_indicator_visibility = value;
#line 158 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_stop_indicator_visibility) {
#line 451 "ProgressBar.c"
		GtkBox* _tmp0_;
#line 159 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = self->priv->stop_indicator;
#line 159 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 457 "ProgressBar.c"
	} else {
		GtkBox* _tmp1_;
#line 161 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = self->priv->stop_indicator;
#line 161 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 464 "ProgressBar.c"
	}
#line 156 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_STOP_INDICATOR_VISIBILITY_PROPERTY]);
#line 468 "ProgressBar.c"
}

gboolean
he_progress_bar_get_is_osd (HeProgressBar* self)
{
	gboolean result;
#line 171 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_is_osd;
#line 172 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 481 "ProgressBar.c"
}

void
he_progress_bar_set_is_osd (HeProgressBar* self,
                            gboolean value)
{
#line 174 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 175 "../lib/Widgets/ProgressBar.vala"
	self->priv->_is_osd = value;
#line 176 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_is_osd) {
#line 177 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_is_wavy) {
#line 496 "ProgressBar.c"
			GtkDrawingArea* _tmp0_;
#line 178 "../lib/Widgets/ProgressBar.vala"
			_tmp0_ = self->priv->wavy_drawing_area;
#line 178 "../lib/Widgets/ProgressBar.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "osd");
#line 502 "ProgressBar.c"
		} else {
			GtkProgressBar* _tmp1_;
#line 180 "../lib/Widgets/ProgressBar.vala"
			_tmp1_ = self->progressbar;
#line 180 "../lib/Widgets/ProgressBar.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "osd");
#line 509 "ProgressBar.c"
		}
	} else {
#line 183 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_is_wavy) {
#line 514 "ProgressBar.c"
			GtkDrawingArea* _tmp2_;
#line 184 "../lib/Widgets/ProgressBar.vala"
			_tmp2_ = self->priv->wavy_drawing_area;
#line 184 "../lib/Widgets/ProgressBar.vala"
			gtk_widget_remove_css_class ((GtkWidget*) _tmp2_, "osd");
#line 520 "ProgressBar.c"
		} else {
			GtkProgressBar* _tmp3_;
#line 186 "../lib/Widgets/ProgressBar.vala"
			_tmp3_ = self->progressbar;
#line 186 "../lib/Widgets/ProgressBar.vala"
			gtk_widget_remove_css_class ((GtkWidget*) _tmp3_, "osd");
#line 527 "ProgressBar.c"
		}
	}
#line 174 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_IS_OSD_PROPERTY]);
#line 532 "ProgressBar.c"
}

gboolean
he_progress_bar_get_is_wavy (HeProgressBar* self)
{
	gboolean result;
#line 197 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 198 "../lib/Widgets/ProgressBar.vala"
	result = self->priv->_is_wavy;
#line 198 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 545 "ProgressBar.c"
}

void
he_progress_bar_set_is_wavy (HeProgressBar* self,
                             gboolean value)
{
#line 200 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 201 "../lib/Widgets/ProgressBar.vala"
	self->priv->_is_wavy = value;
#line 202 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_is_wavy) {
#line 558 "ProgressBar.c"
		GtkOverlay* _tmp0_;
		GtkDrawingArea* _tmp1_;
		GtkDrawingArea* _tmp2_;
		gboolean _tmp4_ = FALSE;
#line 203 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = self->priv->pb_overlay;
#line 203 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 203 "../lib/Widgets/ProgressBar.vala"
		gtk_overlay_set_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 205 "../lib/Widgets/ProgressBar.vala"
		_tmp2_ = self->priv->wavy_drawing_area;
#line 205 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp2_);
#line 206 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_update_stop_indicator_position (self);
#line 208 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_is_osd) {
#line 577 "ProgressBar.c"
			GtkDrawingArea* _tmp3_;
#line 209 "../lib/Widgets/ProgressBar.vala"
			_tmp3_ = self->priv->wavy_drawing_area;
#line 209 "../lib/Widgets/ProgressBar.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "osd");
#line 583 "ProgressBar.c"
		}
#line 212 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_progress >= 0.9) {
#line 212 "../lib/Widgets/ProgressBar.vala"
			_tmp4_ = !self->priv->_is_flattening;
#line 589 "ProgressBar.c"
		} else {
#line 212 "../lib/Widgets/ProgressBar.vala"
			_tmp4_ = FALSE;
#line 593 "ProgressBar.c"
		}
#line 212 "../lib/Widgets/ProgressBar.vala"
		if (_tmp4_) {
#line 213 "../lib/Widgets/ProgressBar.vala"
			self->priv->_is_flattening = TRUE;
#line 214 "../lib/Widgets/ProgressBar.vala"
			self->priv->_flatten_start_time = g_get_monotonic_time ();
#line 601 "ProgressBar.c"
		}
#line 217 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_start_continuous_animation (self);
#line 605 "ProgressBar.c"
	} else {
		GtkOverlay* _tmp5_;
		GtkProgressBar* _tmp6_;
		GtkProgressBar* _tmp7_;
		GtkBox* _tmp8_;
#line 219 "../lib/Widgets/ProgressBar.vala"
		_tmp5_ = self->priv->pb_overlay;
#line 219 "../lib/Widgets/ProgressBar.vala"
		_tmp6_ = self->progressbar;
#line 219 "../lib/Widgets/ProgressBar.vala"
		gtk_overlay_set_child (_tmp5_, (GtkWidget*) _tmp6_);
#line 221 "../lib/Widgets/ProgressBar.vala"
		_tmp7_ = self->progressbar;
#line 221 "../lib/Widgets/ProgressBar.vala"
		gtk_progress_bar_set_fraction (_tmp7_, self->priv->_progress);
#line 223 "../lib/Widgets/ProgressBar.vala"
		_tmp8_ = self->priv->stop_indicator;
#line 223 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp8_, 14);
#line 225 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_is_osd) {
#line 627 "ProgressBar.c"
			GtkProgressBar* _tmp9_;
#line 226 "../lib/Widgets/ProgressBar.vala"
			_tmp9_ = self->progressbar;
#line 226 "../lib/Widgets/ProgressBar.vala"
			gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "osd");
#line 633 "ProgressBar.c"
		}
#line 229 "../lib/Widgets/ProgressBar.vala"
		self->priv->_is_flattening = FALSE;
#line 231 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_stop_continuous_animation (self);
#line 639 "ProgressBar.c"
	}
#line 200 "../lib/Widgets/ProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_progress_bar_properties[HE_PROGRESS_BAR_IS_WAVY_PROPERTY]);
#line 643 "ProgressBar.c"
}

/**
     * Constructs a new Progressbar.
     *
     * @since 1.0
     */
HeProgressBar*
he_progress_bar_construct (GType object_type)
{
	HeProgressBar * self = NULL;
#line 241 "../lib/Widgets/ProgressBar.vala"
	self = (HeProgressBar*) he_bin_construct (object_type);
#line 241 "../lib/Widgets/ProgressBar.vala"
	return self;
#line 659 "ProgressBar.c"
}

HeProgressBar*
he_progress_bar_new (void)
{
#line 241 "../lib/Widgets/ProgressBar.vala"
	return he_progress_bar_construct (HE_TYPE_PROGRESS_BAR);
#line 667 "ProgressBar.c"
}

/**
     * Gets the He.Application instance from the widget hierarchy.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 301 "../lib/Widgets/ProgressBar.vala"
	return self ? g_object_ref (self) : NULL;
#line 678 "ProgressBar.c"
}

static HeApplication*
he_progress_bar_get_he_application (HeProgressBar* self)
{
	GtkRoot* root = NULL;
	GtkRoot* _tmp0_;
	GtkRoot* _tmp1_;
	GtkRoot* _tmp2_;
	HeApplication* result;
#line 300 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 301 "../lib/Widgets/ProgressBar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 301 "../lib/Widgets/ProgressBar.vala"
	root = _tmp1_;
#line 302 "../lib/Widgets/ProgressBar.vala"
	_tmp2_ = root;
#line 302 "../lib/Widgets/ProgressBar.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ())) {
#line 701 "ProgressBar.c"
		GtkApplication* app = NULL;
		GtkRoot* _tmp3_;
		GtkApplication* _tmp4_;
		GtkApplication* _tmp5_;
		GtkApplication* _tmp6_;
#line 303 "../lib/Widgets/ProgressBar.vala"
		_tmp3_ = root;
#line 303 "../lib/Widgets/ProgressBar.vala"
		_tmp4_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
#line 303 "../lib/Widgets/ProgressBar.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 303 "../lib/Widgets/ProgressBar.vala"
		app = _tmp5_;
#line 304 "../lib/Widgets/ProgressBar.vala"
		_tmp6_ = app;
#line 304 "../lib/Widgets/ProgressBar.vala"
		if (HE_IS_APPLICATION (_tmp6_)) {
#line 719 "ProgressBar.c"
			GtkApplication* _tmp7_;
			HeApplication* _tmp8_;
#line 305 "../lib/Widgets/ProgressBar.vala"
			_tmp7_ = app;
#line 305 "../lib/Widgets/ProgressBar.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, HE_TYPE_APPLICATION, HeApplication));
#line 305 "../lib/Widgets/ProgressBar.vala"
			result = _tmp8_;
#line 305 "../lib/Widgets/ProgressBar.vala"
			_g_object_unref0 (app);
#line 305 "../lib/Widgets/ProgressBar.vala"
			_g_object_unref0 (root);
#line 305 "../lib/Widgets/ProgressBar.vala"
			return result;
#line 734 "ProgressBar.c"
		}
#line 302 "../lib/Widgets/ProgressBar.vala"
		_g_object_unref0 (app);
#line 738 "ProgressBar.c"
	}
#line 308 "../lib/Widgets/ProgressBar.vala"
	result = NULL;
#line 308 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (root);
#line 308 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 746 "ProgressBar.c"
}

/**
     * Updates the stop indicator position to align with the wavy progress end.
     */
static void
he_progress_bar_update_stop_indicator_position (HeProgressBar* self)
{
	gboolean _tmp0_ = FALSE;
#line 314 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 315 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_is_wavy) {
#line 315 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = self->priv->_stop_indicator_visibility;
#line 762 "ProgressBar.c"
	} else {
#line 315 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = FALSE;
#line 766 "ProgressBar.c"
	}
#line 315 "../lib/Widgets/ProgressBar.vala"
	if (_tmp0_) {
#line 770 "ProgressBar.c"
		GtkBox* _tmp1_;
#line 317 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = self->priv->stop_indicator;
#line 317 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, 0);
#line 776 "ProgressBar.c"
	}
}

static gpointer
_he_rgb_color_dup0 (gpointer self)
{
#line 334 "../lib/Widgets/ProgressBar.vala"
	return self ? he_rgb_color_dup (self) : NULL;
#line 785 "ProgressBar.c"
}

static void
he_progress_bar_update_accent_color (HeProgressBar* self)
{
	HeRGBColor* effective_color = NULL;
	gboolean is_from_application = FALSE;
	HeApplication* app = NULL;
	HeApplication* _tmp0_;
	HeApplication* _tmp1_;
	HeRGBColor* _tmp11_;
	HeRGBColor* _tmp16_;
#line 321 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 322 "../lib/Widgets/ProgressBar.vala"
	effective_color = NULL;
#line 323 "../lib/Widgets/ProgressBar.vala"
	is_from_application = FALSE;
#line 326 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = he_progress_bar_get_he_application (self);
#line 326 "../lib/Widgets/ProgressBar.vala"
	app = _tmp0_;
#line 327 "../lib/Widgets/ProgressBar.vala"
	_tmp1_ = app;
#line 327 "../lib/Widgets/ProgressBar.vala"
	if (_tmp1_ != NULL) {
#line 812 "ProgressBar.c"
		HeApplication* _tmp2_;
		HeRGBColor* _tmp3_;
		gboolean _tmp4_ = FALSE;
		HeApplication* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 328 "../lib/Widgets/ProgressBar.vala"
		_tmp2_ = app;
#line 328 "../lib/Widgets/ProgressBar.vala"
		_tmp3_ = he_application_get_effective_accent_color (_tmp2_);
#line 328 "../lib/Widgets/ProgressBar.vala"
		_he_rgb_color_free0 (effective_color);
#line 328 "../lib/Widgets/ProgressBar.vala"
		effective_color = _tmp3_;
#line 329 "../lib/Widgets/ProgressBar.vala"
		_tmp5_ = app;
#line 329 "../lib/Widgets/ProgressBar.vala"
		_tmp6_ = he_application_get_is_content (_tmp5_);
#line 329 "../lib/Widgets/ProgressBar.vala"
		_tmp7_ = _tmp6_;
#line 329 "../lib/Widgets/ProgressBar.vala"
		if (_tmp7_) {
#line 835 "ProgressBar.c"
			HeApplication* _tmp8_;
			HeRGBColor* _tmp9_;
			HeRGBColor* _tmp10_;
#line 329 "../lib/Widgets/ProgressBar.vala"
			_tmp8_ = app;
#line 329 "../lib/Widgets/ProgressBar.vala"
			_tmp9_ = he_application_get_default_accent_color (_tmp8_);
#line 329 "../lib/Widgets/ProgressBar.vala"
			_tmp10_ = _tmp9_;
#line 329 "../lib/Widgets/ProgressBar.vala"
			_tmp4_ = _tmp10_ != NULL;
#line 847 "ProgressBar.c"
		} else {
#line 329 "../lib/Widgets/ProgressBar.vala"
			_tmp4_ = FALSE;
#line 851 "ProgressBar.c"
		}
#line 329 "../lib/Widgets/ProgressBar.vala"
		is_from_application = _tmp4_;
#line 855 "ProgressBar.c"
	}
#line 333 "../lib/Widgets/ProgressBar.vala"
	_tmp11_ = effective_color;
#line 333 "../lib/Widgets/ProgressBar.vala"
	if (_tmp11_ == NULL) {
#line 861 "ProgressBar.c"
		HeDesktop* _tmp12_;
		HeRGBColor* _tmp13_;
		HeRGBColor* _tmp14_;
		HeRGBColor* _tmp15_;
#line 334 "../lib/Widgets/ProgressBar.vala"
		_tmp12_ = self->priv->desktop;
#line 334 "../lib/Widgets/ProgressBar.vala"
		_tmp13_ = he_desktop_get_accent_color (_tmp12_);
#line 334 "../lib/Widgets/ProgressBar.vala"
		_tmp14_ = _tmp13_;
#line 334 "../lib/Widgets/ProgressBar.vala"
		_tmp15_ = _he_rgb_color_dup0 (_tmp14_);
#line 334 "../lib/Widgets/ProgressBar.vala"
		_he_rgb_color_free0 (effective_color);
#line 334 "../lib/Widgets/ProgressBar.vala"
		effective_color = _tmp15_;
#line 878 "ProgressBar.c"
	}
#line 337 "../lib/Widgets/ProgressBar.vala"
	_tmp16_ = effective_color;
#line 337 "../lib/Widgets/ProgressBar.vala"
	if (_tmp16_ != NULL) {
#line 884 "ProgressBar.c"
		gfloat r = 0.0F;
		gfloat g = 0.0F;
		gfloat b = 0.0F;
		GdkRGBA _tmp23_ = {0};
		const gchar* _tmp24_ = NULL;
		HeRGBColor* _tmp25_;
		HeRGBColor* _tmp26_;
		HeRGBColor* _tmp27_;
#line 340 "../lib/Widgets/ProgressBar.vala"
		if (is_from_application) {
#line 895 "ProgressBar.c"
			HeRGBColor* _tmp17_;
			HeRGBColor* _tmp18_;
			HeRGBColor* _tmp19_;
#line 342 "../lib/Widgets/ProgressBar.vala"
			_tmp17_ = effective_color;
#line 342 "../lib/Widgets/ProgressBar.vala"
			r = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp17_).r))) / 255.0f;
#line 343 "../lib/Widgets/ProgressBar.vala"
			_tmp18_ = effective_color;
#line 343 "../lib/Widgets/ProgressBar.vala"
			g = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp18_).g))) / 255.0f;
#line 344 "../lib/Widgets/ProgressBar.vala"
			_tmp19_ = effective_color;
#line 344 "../lib/Widgets/ProgressBar.vala"
			b = ((gfloat) fmax (0.0, fmin (255.0, (*_tmp19_).b))) / 255.0f;
#line 911 "ProgressBar.c"
		} else {
			HeRGBColor* _tmp20_;
			HeRGBColor* _tmp21_;
			HeRGBColor* _tmp22_;
#line 347 "../lib/Widgets/ProgressBar.vala"
			_tmp20_ = effective_color;
#line 347 "../lib/Widgets/ProgressBar.vala"
			r = (gfloat) fmax (0.0, fmin (1.0, (*_tmp20_).r));
#line 348 "../lib/Widgets/ProgressBar.vala"
			_tmp21_ = effective_color;
#line 348 "../lib/Widgets/ProgressBar.vala"
			g = (gfloat) fmax (0.0, fmin (1.0, (*_tmp21_).g));
#line 349 "../lib/Widgets/ProgressBar.vala"
			_tmp22_ = effective_color;
#line 349 "../lib/Widgets/ProgressBar.vala"
			b = (gfloat) fmax (0.0, fmin (1.0, (*_tmp22_).b));
#line 928 "ProgressBar.c"
		}
#line 352 "../lib/Widgets/ProgressBar.vala"
		_tmp23_.red = r;
#line 352 "../lib/Widgets/ProgressBar.vala"
		_tmp23_.green = g;
#line 352 "../lib/Widgets/ProgressBar.vala"
		_tmp23_.blue = b;
#line 352 "../lib/Widgets/ProgressBar.vala"
		_tmp23_.alpha = 1.0f;
#line 352 "../lib/Widgets/ProgressBar.vala"
		self->priv->accent_color = _tmp23_;
#line 356 "../lib/Widgets/ProgressBar.vala"
		if (is_from_application) {
#line 356 "../lib/Widgets/ProgressBar.vala"
			_tmp24_ = "application";
#line 944 "ProgressBar.c"
		} else {
#line 356 "../lib/Widgets/ProgressBar.vala"
			_tmp24_ = "desktop";
#line 948 "ProgressBar.c"
		}
#line 355 "../lib/Widgets/ProgressBar.vala"
		_tmp25_ = effective_color;
#line 355 "../lib/Widgets/ProgressBar.vala"
		_tmp26_ = effective_color;
#line 355 "../lib/Widgets/ProgressBar.vala"
		_tmp27_ = effective_color;
#line 355 "../lib/Widgets/ProgressBar.vala"
		g_print ("ProgressBar accent color updated: r=%f, g=%f, b=%f (from %s, original:" \
" %f,%f,%f)\n", (gdouble) r, (gdouble) g, (gdouble) b, _tmp24_, (*_tmp25_).r, (*_tmp26_).g, (*_tmp27_).b);
#line 958 "ProgressBar.c"
	} else {
		GdkRGBA _tmp28_ = {0};
#line 360 "../lib/Widgets/ProgressBar.vala"
		_tmp28_.red = 0.2f;
#line 360 "../lib/Widgets/ProgressBar.vala"
		_tmp28_.green = 0.6f;
#line 360 "../lib/Widgets/ProgressBar.vala"
		_tmp28_.blue = 1.0f;
#line 360 "../lib/Widgets/ProgressBar.vala"
		_tmp28_.alpha = 1.0f;
#line 360 "../lib/Widgets/ProgressBar.vala"
		self->priv->accent_color = _tmp28_;
#line 361 "../lib/Widgets/ProgressBar.vala"
		g_print ("ProgressBar using fallback accent color\n");
#line 973 "ProgressBar.c"
	}
#line 321 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (app);
#line 321 "../lib/Widgets/ProgressBar.vala"
	_he_rgb_color_free0 (effective_color);
#line 979 "ProgressBar.c"
}

/**
     * Animation tick callback.
     */
static gboolean
he_progress_bar_on_animation_tick (HeProgressBar* self,
                                   GtkWidget* widget,
                                   GdkFrameClock* frame_clock)
{
	gboolean _tmp0_ = FALSE;
	GtkDrawingArea* _tmp1_;
	gboolean result;
#line 368 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 368 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 368 "../lib/Widgets/ProgressBar.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 370 "../lib/Widgets/ProgressBar.vala"
	if (!self->priv->_continuous_animation) {
#line 370 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = TRUE;
#line 1003 "ProgressBar.c"
	} else {
#line 370 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = !self->priv->_animate;
#line 1007 "ProgressBar.c"
	}
#line 370 "../lib/Widgets/ProgressBar.vala"
	if (_tmp0_) {
#line 371 "../lib/Widgets/ProgressBar.vala"
		self->priv->_animation_tick_id = (guint) 0;
#line 372 "../lib/Widgets/ProgressBar.vala"
		result = FALSE;
#line 372 "../lib/Widgets/ProgressBar.vala"
		return result;
#line 1017 "ProgressBar.c"
	}
#line 376 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_phase = self->priv->_wave_phase + (self->priv->_wave_wavelength * 0.0025);
#line 377 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_wave_phase > (2.0 * G_PI)) {
#line 378 "../lib/Widgets/ProgressBar.vala"
		self->priv->_wave_phase = self->priv->_wave_phase - (2.0 * G_PI);
#line 1025 "ProgressBar.c"
	}
#line 382 "../lib/Widgets/ProgressBar.vala"
	_tmp1_ = self->priv->wavy_drawing_area;
#line 382 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 383 "../lib/Widgets/ProgressBar.vala"
	result = TRUE;
#line 383 "../lib/Widgets/ProgressBar.vala"
	return result;
#line 1035 "ProgressBar.c"
}

/**
     * Starts continuous wave animation (internal).
     */
static void
he_progress_bar_start_continuous_animation (HeProgressBar* self)
{
	gboolean _tmp0_ = FALSE;
#line 389 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 390 "../lib/Widgets/ProgressBar.vala"
	self->priv->_continuous_animation = TRUE;
#line 391 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_animate) {
#line 391 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = self->priv->_animation_tick_id == ((guint) 0);
#line 1053 "ProgressBar.c"
	} else {
#line 391 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = FALSE;
#line 1057 "ProgressBar.c"
	}
#line 391 "../lib/Widgets/ProgressBar.vala"
	if (_tmp0_) {
#line 1061 "ProgressBar.c"
		GtkDrawingArea* _tmp1_;
#line 392 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = self->priv->wavy_drawing_area;
#line 392 "../lib/Widgets/ProgressBar.vala"
		self->priv->_animation_tick_id = gtk_widget_add_tick_callback ((GtkWidget*) _tmp1_, _he_progress_bar_on_animation_tick_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 1067 "ProgressBar.c"
	}
}

/**
     * Stops continuous wave animation (internal).
     */
static void
he_progress_bar_stop_continuous_animation (HeProgressBar* self)
{
#line 399 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 400 "../lib/Widgets/ProgressBar.vala"
	self->priv->_continuous_animation = FALSE;
#line 401 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_animation_tick_id != ((guint) 0)) {
#line 1083 "ProgressBar.c"
		GtkDrawingArea* _tmp0_;
#line 402 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = self->priv->wavy_drawing_area;
#line 402 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_remove_tick_callback ((GtkWidget*) _tmp0_, self->priv->_animation_tick_id);
#line 403 "../lib/Widgets/ProgressBar.vala"
		self->priv->_animation_tick_id = (guint) 0;
#line 1091 "ProgressBar.c"
	}
}

/**
     * Draws the wavy progress indicator using Cairo.
     */
static void
he_progress_bar_draw_wavy_progress (HeProgressBar* self,
                                    GtkDrawingArea* area,
                                    cairo_t* cr,
                                    gint width,
                                    gint height)
{
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	GdkRGBA bg_color = {0};
	GdkRGBA _tmp3_ = {0};
	gdouble effective_width = 0.0;
	gdouble progress_width = 0.0;
	gdouble center_y = 0.0;
#line 415 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 415 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (area != NULL);
#line 415 "../lib/Widgets/ProgressBar.vala"
	g_return_if_fail (cr != NULL);
#line 417 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->is_dark) {
#line 417 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = 1.0f;
#line 1123 "ProgressBar.c"
	} else {
#line 417 "../lib/Widgets/ProgressBar.vala"
		_tmp0_ = 0.0f;
#line 1127 "ProgressBar.c"
	}
#line 417 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->is_dark) {
#line 417 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = 1.0f;
#line 1133 "ProgressBar.c"
	} else {
#line 417 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = 0.0f;
#line 1137 "ProgressBar.c"
	}
#line 417 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->is_dark) {
#line 417 "../lib/Widgets/ProgressBar.vala"
		_tmp2_ = 1.0f;
#line 1143 "ProgressBar.c"
	} else {
#line 417 "../lib/Widgets/ProgressBar.vala"
		_tmp2_ = 0.0f;
#line 1147 "ProgressBar.c"
	}
#line 417 "../lib/Widgets/ProgressBar.vala"
	_tmp3_.red = _tmp0_;
#line 417 "../lib/Widgets/ProgressBar.vala"
	_tmp3_.green = _tmp1_;
#line 417 "../lib/Widgets/ProgressBar.vala"
	_tmp3_.blue = _tmp2_;
#line 417 "../lib/Widgets/ProgressBar.vala"
	_tmp3_.alpha = 0.12f;
#line 417 "../lib/Widgets/ProgressBar.vala"
	bg_color = _tmp3_;
#line 419 "../lib/Widgets/ProgressBar.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->_wave_thickness);
#line 420 "../lib/Widgets/ProgressBar.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 423 "../lib/Widgets/ProgressBar.vala"
	effective_width = (gdouble) (width - (2 * HE_PROGRESS_BAR_PROGRESS_MARGIN));
#line 424 "../lib/Widgets/ProgressBar.vala"
	progress_width = HE_PROGRESS_BAR_PROGRESS_MARGIN + (effective_width * self->priv->_progress);
#line 425 "../lib/Widgets/ProgressBar.vala"
	center_y = height * 0.5;
#line 428 "../lib/Widgets/ProgressBar.vala"
	if (progress_width < ((gdouble) (width - HE_PROGRESS_BAR_PROGRESS_MARGIN))) {
#line 1171 "ProgressBar.c"
		GdkRGBA _tmp4_;
		GdkRGBA _tmp5_;
		GdkRGBA _tmp6_;
		GdkRGBA _tmp7_;
#line 429 "../lib/Widgets/ProgressBar.vala"
		_tmp4_ = bg_color;
#line 429 "../lib/Widgets/ProgressBar.vala"
		_tmp5_ = bg_color;
#line 429 "../lib/Widgets/ProgressBar.vala"
		_tmp6_ = bg_color;
#line 429 "../lib/Widgets/ProgressBar.vala"
		_tmp7_ = bg_color;
#line 429 "../lib/Widgets/ProgressBar.vala"
		cairo_set_source_rgba (cr, (gdouble) _tmp4_.red, (gdouble) _tmp5_.green, (gdouble) _tmp6_.blue, (gdouble) _tmp7_.alpha);
#line 430 "../lib/Widgets/ProgressBar.vala"
		cairo_move_to (cr, progress_width + 6.0, center_y);
#line 431 "../lib/Widgets/ProgressBar.vala"
		cairo_line_to (cr, (gdouble) (width - HE_PROGRESS_BAR_PROGRESS_MARGIN), center_y);
#line 432 "../lib/Widgets/ProgressBar.vala"
		cairo_stroke (cr);
#line 1192 "ProgressBar.c"
	}
#line 436 "../lib/Widgets/ProgressBar.vala"
	if (progress_width > ((gdouble) HE_PROGRESS_BAR_PROGRESS_MARGIN)) {
#line 1196 "ProgressBar.c"
		gfloat _tmp8_ = 0.0F;
		gfloat _tmp9_ = 0.0F;
		gfloat _tmp10_ = 0.0F;
		GdkRGBA _tmp11_;
		GdkRGBA _tmp12_;
		GdkRGBA _tmp13_;
		gdouble wave_height = 0.0;
		gdouble wave_frequency = 0.0;
		gdouble start_y = 0.0;
#line 437 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->is_dark) {
#line 437 "../lib/Widgets/ProgressBar.vala"
			_tmp8_ = 0.50f;
#line 1210 "ProgressBar.c"
		} else {
#line 437 "../lib/Widgets/ProgressBar.vala"
			_tmp8_ = 0.60f;
#line 1214 "ProgressBar.c"
		}
#line 437 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->is_dark) {
#line 437 "../lib/Widgets/ProgressBar.vala"
			_tmp9_ = 0.50f;
#line 1220 "ProgressBar.c"
		} else {
#line 437 "../lib/Widgets/ProgressBar.vala"
			_tmp9_ = 0.60f;
#line 1224 "ProgressBar.c"
		}
#line 437 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->is_dark) {
#line 437 "../lib/Widgets/ProgressBar.vala"
			_tmp10_ = 0.50f;
#line 1230 "ProgressBar.c"
		} else {
#line 437 "../lib/Widgets/ProgressBar.vala"
			_tmp10_ = 0.60f;
#line 1234 "ProgressBar.c"
		}
#line 437 "../lib/Widgets/ProgressBar.vala"
		_tmp11_ = self->priv->accent_color;
#line 437 "../lib/Widgets/ProgressBar.vala"
		_tmp12_ = self->priv->accent_color;
#line 437 "../lib/Widgets/ProgressBar.vala"
		_tmp13_ = self->priv->accent_color;
#line 437 "../lib/Widgets/ProgressBar.vala"
		cairo_set_source_rgba (cr, (gdouble) (_tmp8_ * _tmp11_.red), (gdouble) (_tmp9_ * _tmp12_.green), (gdouble) (_tmp10_ * _tmp13_.blue), (gdouble) 1.0f);
#line 440 "../lib/Widgets/ProgressBar.vala"
		wave_height = (gdouble) self->priv->_wave_amplitude;
#line 441 "../lib/Widgets/ProgressBar.vala"
		wave_frequency = (2.0 * G_PI) / self->priv->_wave_wavelength;
#line 444 "../lib/Widgets/ProgressBar.vala"
		if (self->priv->_is_flattening) {
#line 1250 "ProgressBar.c"
			gint64 current_time = 0LL;
			gint64 elapsed = 0LL;
#line 445 "../lib/Widgets/ProgressBar.vala"
			current_time = g_get_monotonic_time ();
#line 446 "../lib/Widgets/ProgressBar.vala"
			elapsed = current_time - self->priv->_flatten_start_time;
#line 448 "../lib/Widgets/ProgressBar.vala"
			if (elapsed < HE_PROGRESS_BAR_FLATTEN_DURATION) {
#line 1259 "ProgressBar.c"
				gdouble flatten_factor = 0.0;
#line 450 "../lib/Widgets/ProgressBar.vala"
				flatten_factor = ((gdouble) elapsed) / ((gdouble) HE_PROGRESS_BAR_FLATTEN_DURATION);
#line 451 "../lib/Widgets/ProgressBar.vala"
				flatten_factor = fmin (1.0, flatten_factor);
#line 452 "../lib/Widgets/ProgressBar.vala"
				wave_height *= 1.0 - flatten_factor;
#line 1267 "ProgressBar.c"
			} else {
#line 455 "../lib/Widgets/ProgressBar.vala"
				wave_height = 0.0;
#line 1271 "ProgressBar.c"
			}
		}
#line 460 "../lib/Widgets/ProgressBar.vala"
		start_y = center_y + (sin (self->priv->_wave_phase) * wave_height);
#line 461 "../lib/Widgets/ProgressBar.vala"
		cairo_move_to (cr, (gdouble) HE_PROGRESS_BAR_PROGRESS_MARGIN, start_y);
#line 1278 "ProgressBar.c"
		{
			gdouble x = 0.0;
#line 463 "../lib/Widgets/ProgressBar.vala"
			x = HE_PROGRESS_BAR_PROGRESS_MARGIN + 1.0;
#line 1283 "ProgressBar.c"
			{
				gboolean _tmp14_ = FALSE;
#line 463 "../lib/Widgets/ProgressBar.vala"
				_tmp14_ = TRUE;
#line 463 "../lib/Widgets/ProgressBar.vala"
				while (TRUE) {
#line 1290 "ProgressBar.c"
					gdouble y = 0.0;
#line 463 "../lib/Widgets/ProgressBar.vala"
					if (!_tmp14_) {
#line 463 "../lib/Widgets/ProgressBar.vala"
						x += 1.0;
#line 1296 "ProgressBar.c"
					}
#line 463 "../lib/Widgets/ProgressBar.vala"
					_tmp14_ = FALSE;
#line 463 "../lib/Widgets/ProgressBar.vala"
					if (!(x <= progress_width)) {
#line 463 "../lib/Widgets/ProgressBar.vala"
						break;
#line 1304 "ProgressBar.c"
					}
#line 464 "../lib/Widgets/ProgressBar.vala"
					y = center_y + (sin (((x - HE_PROGRESS_BAR_PROGRESS_MARGIN) * wave_frequency) + self->priv->_wave_phase) * wave_height);
#line 465 "../lib/Widgets/ProgressBar.vala"
					cairo_line_to (cr, x, y);
#line 1310 "ProgressBar.c"
				}
			}
		}
#line 468 "../lib/Widgets/ProgressBar.vala"
		cairo_stroke (cr);
#line 1316 "ProgressBar.c"
	}
}

static void
_he_progress_bar_draw_wavy_progress_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 262 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_draw_wavy_progress ((HeProgressBar*) self, drawing_area, cr, width, height);
#line 1329 "ProgressBar.c"
}

static void
_he_progress_bar_update_accent_color_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 277 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_update_accent_color ((HeProgressBar*) self);
#line 1339 "ProgressBar.c"
}

static void
_he_progress_bar_update_accent_color_he_application_accent_color_changed (HeApplication* _sender,
                                                                          gpointer self)
{
#line 283 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_update_accent_color ((HeProgressBar*) self);
#line 1348 "ProgressBar.c"
}

static void
_he_progress_bar___lambda138_ (HeProgressBar* self)
{
	HeApplication* app = NULL;
	HeApplication* _tmp0_;
	HeApplication* _tmp1_;
#line 281 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = he_progress_bar_get_he_application (self);
#line 281 "../lib/Widgets/ProgressBar.vala"
	app = _tmp0_;
#line 282 "../lib/Widgets/ProgressBar.vala"
	_tmp1_ = app;
#line 282 "../lib/Widgets/ProgressBar.vala"
	if (_tmp1_ != NULL) {
#line 1365 "ProgressBar.c"
		HeApplication* _tmp2_;
		GtkDrawingArea* _tmp3_;
#line 283 "../lib/Widgets/ProgressBar.vala"
		_tmp2_ = app;
#line 283 "../lib/Widgets/ProgressBar.vala"
		g_signal_connect_object (_tmp2_, "accent-color-changed", (GCallback) _he_progress_bar_update_accent_color_he_application_accent_color_changed, self, 0);
#line 284 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_update_accent_color (self);
#line 285 "../lib/Widgets/ProgressBar.vala"
		_tmp3_ = self->priv->wavy_drawing_area;
#line 285 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
#line 1378 "ProgressBar.c"
	}
#line 280 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (app);
#line 1382 "ProgressBar.c"
}

static void
__he_progress_bar___lambda138__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 280 "../lib/Widgets/ProgressBar.vala"
	_he_progress_bar___lambda138_ ((HeProgressBar*) self);
#line 1392 "ProgressBar.c"
}

static GObject *
he_progress_bar_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeProgressBar * self;
	GtkBox* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkDrawingArea* _tmp7_;
	GtkDrawingArea* _tmp8_;
	GtkDrawingArea* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkOverlay* _tmp11_;
	GtkBox* _tmp12_;
	GtkOverlay* _tmp13_;
	GtkProgressBar* _tmp14_;
	GtkBox* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	gboolean _tmp21_ = FALSE;
	HeDesktop* _tmp22_;
	HeDesktopColorScheme _tmp23_;
	HeDesktopColorScheme _tmp24_;
	HeDesktop* _tmp25_;
	GtkDrawingArea* _tmp26_;
#line 248 "../lib/Widgets/ProgressBar.vala"
	parent_class = G_OBJECT_CLASS (he_progress_bar_parent_class);
#line 248 "../lib/Widgets/ProgressBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 248 "../lib/Widgets/ProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_PROGRESS_BAR, HeProgressBar);
#line 249 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = self->priv->stop_indicator;
#line 249 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp0_, 14);
#line 250 "../lib/Widgets/ProgressBar.vala"
	if (self->priv->_is_wavy) {
#line 250 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = self->priv->_stop_indicator_visibility;
#line 1443 "ProgressBar.c"
	} else {
#line 250 "../lib/Widgets/ProgressBar.vala"
		_tmp1_ = FALSE;
#line 1447 "ProgressBar.c"
	}
#line 250 "../lib/Widgets/ProgressBar.vala"
	if (_tmp1_) {
#line 1451 "ProgressBar.c"
		GtkBox* _tmp2_;
#line 252 "../lib/Widgets/ProgressBar.vala"
		_tmp2_ = self->priv->stop_indicator;
#line 252 "../lib/Widgets/ProgressBar.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 0);
#line 1457 "ProgressBar.c"
	}
#line 254 "../lib/Widgets/ProgressBar.vala"
	_tmp3_ = self->priv->stop_indicator;
#line 254 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
#line 255 "../lib/Widgets/ProgressBar.vala"
	_tmp4_ = self->priv->stop_indicator;
#line 255 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_END);
#line 256 "../lib/Widgets/ProgressBar.vala"
	_tmp5_ = self->priv->stop_indicator;
#line 256 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 257 "../lib/Widgets/ProgressBar.vala"
	_tmp6_ = self->priv->stop_indicator;
#line 257 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "stop-indicator");
#line 260 "../lib/Widgets/ProgressBar.vala"
	_tmp7_ = self->priv->wavy_drawing_area;
#line 260 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
#line 261 "../lib/Widgets/ProgressBar.vala"
	_tmp8_ = self->priv->wavy_drawing_area;
#line 261 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp8_, -1, 40);
#line 262 "../lib/Widgets/ProgressBar.vala"
	_tmp9_ = self->priv->wavy_drawing_area;
#line 262 "../lib/Widgets/ProgressBar.vala"
	gtk_drawing_area_set_draw_func (_tmp9_, _he_progress_bar_draw_wavy_progress_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 264 "../lib/Widgets/ProgressBar.vala"
	_tmp10_ = self->priv->pb_overlay;
#line 264 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp10_, TRUE);
#line 265 "../lib/Widgets/ProgressBar.vala"
	_tmp11_ = self->priv->pb_overlay;
#line 265 "../lib/Widgets/ProgressBar.vala"
	_tmp12_ = self->priv->stop_indicator;
#line 265 "../lib/Widgets/ProgressBar.vala"
	gtk_overlay_add_overlay (_tmp11_, (GtkWidget*) _tmp12_);
#line 266 "../lib/Widgets/ProgressBar.vala"
	_tmp13_ = self->priv->pb_overlay;
#line 266 "../lib/Widgets/ProgressBar.vala"
	_tmp14_ = self->progressbar;
#line 266 "../lib/Widgets/ProgressBar.vala"
	gtk_overlay_set_child (_tmp13_, (GtkWidget*) _tmp14_);
#line 268 "../lib/Widgets/ProgressBar.vala"
	_tmp15_ = self->priv->main_box;
#line 268 "../lib/Widgets/ProgressBar.vala"
	_tmp16_ = self->priv->pb_overlay;
#line 268 "../lib/Widgets/ProgressBar.vala"
	gtk_box_append (_tmp15_, (GtkWidget*) _tmp16_);
#line 269 "../lib/Widgets/ProgressBar.vala"
	_tmp17_ = self->priv->main_box;
#line 269 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 270 "../lib/Widgets/ProgressBar.vala"
	_tmp18_ = self->priv->main_box;
#line 270 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
#line 271 "../lib/Widgets/ProgressBar.vala"
	_tmp19_ = self->priv->main_box;
#line 271 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "progressbar");
#line 272 "../lib/Widgets/ProgressBar.vala"
	_tmp20_ = self->priv->main_box;
#line 272 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp20_, (GtkWidget*) self);
#line 274 "../lib/Widgets/ProgressBar.vala"
	_tmp22_ = self->priv->desktop;
#line 274 "../lib/Widgets/ProgressBar.vala"
	_tmp23_ = he_desktop_get_prefers_color_scheme (_tmp22_);
#line 274 "../lib/Widgets/ProgressBar.vala"
	_tmp24_ = _tmp23_;
#line 274 "../lib/Widgets/ProgressBar.vala"
	if (_tmp24_ == HE_DESKTOP_COLOR_SCHEME_DARK) {
#line 274 "../lib/Widgets/ProgressBar.vala"
		_tmp21_ = TRUE;
#line 1535 "ProgressBar.c"
	} else {
#line 274 "../lib/Widgets/ProgressBar.vala"
		_tmp21_ = FALSE;
#line 1539 "ProgressBar.c"
	}
#line 274 "../lib/Widgets/ProgressBar.vala"
	self->priv->is_dark = _tmp21_;
#line 277 "../lib/Widgets/ProgressBar.vala"
	_tmp25_ = self->priv->desktop;
#line 277 "../lib/Widgets/ProgressBar.vala"
	g_signal_connect_object ((GObject*) _tmp25_, "notify::accent-color", (GCallback) _he_progress_bar_update_accent_color_g_object_notify, self, 0);
#line 280 "../lib/Widgets/ProgressBar.vala"
	g_signal_connect_object ((GObject*) self, "notify::root", (GCallback) __he_progress_bar___lambda138__g_object_notify, self, 0);
#line 289 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_set_is_osd (self, FALSE);
#line 290 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_set_stop_indicator_visibility (self, TRUE);
#line 291 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_set_is_wavy (self, FALSE);
#line 293 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_update_accent_color (self);
#line 294 "../lib/Widgets/ProgressBar.vala"
	_tmp26_ = self->priv->wavy_drawing_area;
#line 294 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp26_);
#line 248 "../lib/Widgets/ProgressBar.vala"
	return obj;
#line 1563 "ProgressBar.c"
}

static void
he_progress_bar_class_init (HeProgressBarClass * klass,
                            gpointer klass_data)
{
#line 25 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_type_class_adjust_private_offset (klass, &HeProgressBar_private_offset);
#line 25 "../lib/Widgets/ProgressBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_progress_bar_get_property;
#line 25 "../lib/Widgets/ProgressBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_progress_bar_set_property;
#line 25 "../lib/Widgets/ProgressBar.vala"
	G_OBJECT_CLASS (klass)->constructor = he_progress_bar_constructor;
#line 25 "../lib/Widgets/ProgressBar.vala"
	G_OBJECT_CLASS (klass)->finalize = he_progress_bar_finalize;
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_WAVE_AMPLITUDE_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_WAVE_AMPLITUDE_PROPERTY] = g_param_spec_int ("wave-amplitude", "wave-amplitude", "wave-amplitude", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_WAVE_WAVELENGTH_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_WAVE_WAVELENGTH_PROPERTY] = g_param_spec_int ("wave-wavelength", "wave-wavelength", "wave-wavelength", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_WAVE_THICKNESS_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_WAVE_THICKNESS_PROPERTY] = g_param_spec_int ("wave-thickness", "wave-thickness", "wave-thickness", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_ANIMATE_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_ANIMATE_PROPERTY] = g_param_spec_boolean ("animate", "animate", "animate", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_PROGRESS_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_PROGRESS_PROPERTY] = g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_STOP_INDICATOR_VISIBILITY_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_STOP_INDICATOR_VISIBILITY_PROPERTY] = g_param_spec_boolean ("stop-indicator-visibility", "stop-indicator-visibility", "stop-indicator-visibility", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_IS_OSD_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_IS_OSD_PROPERTY] = g_param_spec_boolean ("is-osd", "is-osd", "is-osd", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Widgets/ProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_PROGRESS_BAR_IS_WAVY_PROPERTY, he_progress_bar_properties[HE_PROGRESS_BAR_IS_WAVY_PROPERTY] = g_param_spec_boolean ("is-wavy", "is-wavy", "is-wavy", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 245 "../lib/Widgets/ProgressBar.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 1600 "ProgressBar.c"
}

static void
he_progress_bar_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                              gpointer iface_data)
{
#line 25 "../lib/Widgets/ProgressBar.vala"
	he_progress_bar_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 1609 "ProgressBar.c"
}

static void
he_progress_bar_instance_init (HeProgressBar * self,
                               gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkOverlay* _tmp2_;
	HeDesktop* _tmp3_;
	GtkProgressBar* _tmp4_;
	GtkDrawingArea* _tmp5_;
#line 25 "../lib/Widgets/ProgressBar.vala"
	self->priv = he_progress_bar_get_instance_private (self);
#line 26 "../lib/Widgets/ProgressBar.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 26 "../lib/Widgets/ProgressBar.vala"
	g_object_ref_sink (_tmp0_);
#line 26 "../lib/Widgets/ProgressBar.vala"
	self->priv->main_box = _tmp0_;
#line 27 "../lib/Widgets/ProgressBar.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 27 "../lib/Widgets/ProgressBar.vala"
	g_object_ref_sink (_tmp1_);
#line 27 "../lib/Widgets/ProgressBar.vala"
	self->priv->stop_indicator = _tmp1_;
#line 28 "../lib/Widgets/ProgressBar.vala"
	_tmp2_ = (GtkOverlay*) gtk_overlay_new ();
#line 28 "../lib/Widgets/ProgressBar.vala"
	g_object_ref_sink (_tmp2_);
#line 28 "../lib/Widgets/ProgressBar.vala"
	self->priv->pb_overlay = _tmp2_;
#line 29 "../lib/Widgets/ProgressBar.vala"
	_tmp3_ = he_desktop_new ();
#line 29 "../lib/Widgets/ProgressBar.vala"
	self->priv->desktop = _tmp3_;
#line 31 "../lib/Widgets/ProgressBar.vala"
	self->priv->accent_color = (GdkRGBA) {1.0f, 1.0f, 1.0f, 1.0f};
#line 36 "../lib/Widgets/ProgressBar.vala"
	_tmp4_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 36 "../lib/Widgets/ProgressBar.vala"
	g_object_ref_sink (_tmp4_);
#line 36 "../lib/Widgets/ProgressBar.vala"
	self->progressbar = _tmp4_;
#line 41 "../lib/Widgets/ProgressBar.vala"
	_tmp5_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 41 "../lib/Widgets/ProgressBar.vala"
	g_object_ref_sink (_tmp5_);
#line 41 "../lib/Widgets/ProgressBar.vala"
	self->priv->wavy_drawing_area = _tmp5_;
#line 46 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_amplitude = 4;
#line 58 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_wavelength = 40;
#line 70 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_thickness = 4;
#line 82 "../lib/Widgets/ProgressBar.vala"
	self->priv->_wave_phase = 0.0;
#line 87 "../lib/Widgets/ProgressBar.vala"
	self->priv->_animation_tick_id = (guint) 0;
#line 88 "../lib/Widgets/ProgressBar.vala"
	self->priv->_continuous_animation = FALSE;
#line 93 "../lib/Widgets/ProgressBar.vala"
	self->priv->_is_flattening = FALSE;
#line 94 "../lib/Widgets/ProgressBar.vala"
	self->priv->_flatten_start_time = (gint64) 0;
#line 101 "../lib/Widgets/ProgressBar.vala"
	self->priv->_animate = TRUE;
#line 120 "../lib/Widgets/ProgressBar.vala"
	self->priv->_progress = 0.0;
#line 1680 "ProgressBar.c"
}

static void
he_progress_bar_finalize (GObject * obj)
{
	HeProgressBar * self;
#line 25 "../lib/Widgets/ProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_PROGRESS_BAR, HeProgressBar);
#line 26 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (self->priv->main_box);
#line 27 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (self->priv->stop_indicator);
#line 28 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (self->priv->pb_overlay);
#line 29 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (self->priv->desktop);
#line 36 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (self->progressbar);
#line 41 "../lib/Widgets/ProgressBar.vala"
	_g_object_unref0 (self->priv->wavy_drawing_area);
#line 25 "../lib/Widgets/ProgressBar.vala"
	G_OBJECT_CLASS (he_progress_bar_parent_class)->finalize (obj);
#line 1703 "ProgressBar.c"
}

/**
 * A Progressbar indicates the progress of some process and contains
 * a disable-able Stop Indicator for accessibility purposes.
 * Can display either a standard progressbar or a custom wavy progressbar.
 */
static GType
he_progress_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeProgressBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_progress_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeProgressBar), 0, (GInstanceInitFunc) he_progress_bar_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_progress_bar_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_progress_bar_type_id;
	he_progress_bar_type_id = g_type_register_static (HE_TYPE_BIN, "HeProgressBar", &g_define_type_info, 0);
	g_type_add_interface_static (he_progress_bar_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeProgressBar_private_offset = g_type_add_instance_private (he_progress_bar_type_id, sizeof (HeProgressBarPrivate));
	return he_progress_bar_type_id;
}

GType
he_progress_bar_get_type (void)
{
	static volatile gsize he_progress_bar_type_id__once = 0;
	if (g_once_init_enter (&he_progress_bar_type_id__once)) {
		GType he_progress_bar_type_id;
		he_progress_bar_type_id = he_progress_bar_get_type_once ();
		g_once_init_leave (&he_progress_bar_type_id__once, he_progress_bar_type_id);
	}
	return he_progress_bar_type_id__once;
}

static void
_vala_he_progress_bar_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_PROGRESS_BAR, HeProgressBar);
#line 25 "../lib/Widgets/ProgressBar.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_WAVE_AMPLITUDE_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_int (value, he_progress_bar_get_wave_amplitude (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_WAVE_WAVELENGTH_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_int (value, he_progress_bar_get_wave_wavelength (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_WAVE_THICKNESS_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_int (value, he_progress_bar_get_wave_thickness (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_ANIMATE_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_boolean (value, he_progress_bar_get_animate (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_PROGRESS_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_double (value, he_progress_bar_get_progress (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_STOP_INDICATOR_VISIBILITY_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_boolean (value, he_progress_bar_get_stop_indicator_visibility (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_IS_OSD_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_boolean (value, he_progress_bar_get_is_osd (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_IS_WAVY_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		g_value_set_boolean (value, he_progress_bar_get_is_wavy (self));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 1793 "ProgressBar.c"
		default:
#line 25 "../lib/Widgets/ProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 1799 "ProgressBar.c"
	}
}

static void
_vala_he_progress_bar_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_PROGRESS_BAR, HeProgressBar);
#line 25 "../lib/Widgets/ProgressBar.vala"
	switch (property_id) {
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_WAVE_AMPLITUDE_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_wave_amplitude (self, g_value_get_int (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_WAVE_WAVELENGTH_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_wave_wavelength (self, g_value_get_int (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_WAVE_THICKNESS_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_wave_thickness (self, g_value_get_int (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_ANIMATE_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_animate (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_PROGRESS_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_progress (self, g_value_get_double (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_STOP_INDICATOR_VISIBILITY_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_stop_indicator_visibility (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_IS_OSD_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_is_osd (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 25 "../lib/Widgets/ProgressBar.vala"
		case HE_PROGRESS_BAR_IS_WAVY_PROPERTY:
#line 25 "../lib/Widgets/ProgressBar.vala"
		he_progress_bar_set_is_wavy (self, g_value_get_boolean (value));
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 1861 "ProgressBar.c"
		default:
#line 25 "../lib/Widgets/ProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Widgets/ProgressBar.vala"
		break;
#line 1867 "ProgressBar.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

